<?php
namespace Teknisa\FIN\Modules\ContaReceber\Services\Remessa\Banco;

use Financeiro\Entities\Emprbanc;
use Financeiro\Entities\Boletreceber;
use Geral\Entities\Banco;
use Geral\Entities\Endeclie;
use Geral\Entities\Licencauso;
use Geral\Entities\Contcorr;
use \Geral\Entities\Empresa;
use Geral\Util\Ambiente;
use Teknisa\Libs\Util\DateUtil;
use \Financeiro\Util\Util;
use \Geral\Entities\Cliente;
use Geral\Entities\Filial;
use Teknisa\FIN\Modules\ContaReceber\Services\Remessa\GeraCnabService;

class GeraCnabBtgService extends GeraCnabService{
    
    const CODIGO_BANCO = '208';
    const LOTE_DO_SERVICO_HEADER = '0000';
    const TIPO_ARQUIVO = '0';
    const CODIGO_REMESSA_ARQUIVO = '1';
    const VERSAO_ARQUIVO = '103';
    const DENSIDADE_ARQUIVO = '0000';
    const LOTE_DO_SERVICO = '0001';
    const TIPO_DE_REGISTRO = '1';
    const TIPO_DE_OPERACAO = 'R';
    const TIPO_DE_SERVICO = '01';
    const VERSAO_HEADER_LOTE = '060';
    const TIPO_DE_REGISTRO_DETALHE = '3';
    const CODIGO_SEGMENTO_P = 'P';
    const TIPO_DOCUMENTO = '1';
    const ESPECIE_TITULO = '02';
    const ID_TITULO_ACEITO = 'N';
    const CODIGO_DESCONTO = '0';
    const CODIGO_PARA_BAIXA = '0';
    const CODIGO_MOEDA = '09';
    const CODIGO_SEGMENTO_Q = 'Q';
    const TIPO_DE_REGISTRO_TRAILLER_LOTE = '5';
    const LOTE_DO_SERVICO_TRAILLER = '9999';
    const TIPO_DE_REGISTRO_TRAILLER = '9';
    const CODIGO_SEGMENTO_R = 'R';
    
    
    public function geraHeaderArquivo($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnab, $cdreducont, $carteira = NULL, $contreg = NULL, $idtipcnabrec = NULL, $cdfilial, $contador = NULL){
        
        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "w+");
        
        // CAMPO: Código do Banco na Compensação
        // POSIÇÃO: 01 a 03
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço
        // POSIÇÃO: 04 a 07
        // PICTURE: 9(4) - "0000"
        $arquivo .= self::LOTE_DO_SERVICO_HEADER;
        
        // CAMPO: Tipo de Registro
        // POSIÇÃO: 08 a 08
        // PICTURE: 9(1) - "0"
         $arquivo .= self::TIPO_ARQUIVO;
        
        // CAMPO: Uso Exclusivo FEBRABAN / CNAB
        // POSIÇÃO: 9 a 17 
        // PICTURE: X(1) - Brancos
        $arquivo = str_pad($arquivo, 17);
        
        /** NOTAS
         * '0' = Isento / Não Informado
         * '1' = CPF
         * '2' = CGC / CNPJ
         * '3' = PIS / PASEP
         * '9' = Outros 
         */
         
        // CAMPO: Tipo de Inscrição da Empresa  
        // POSIÇÃO: 18 a 18 
        // PICTURE: 9(1) 
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
        
        if($empresa){
            if($empresa->getIdtpijurempr() == 'F')
                $tipoInscricaoCedente = '1';
            else
                $tipoInscricaoCedente = '2';
        }
        
        $arquivo .= $tipoInscricaoCedente;
        
        // CAMPO: Número de Inscrição da Empresa  
        // POSIÇÃO: 19 a  32  
        // PICTURE: 9(14) 
        if($filial) {
            $arquivo .= Util::campoCnabValido($filial->getNrinsjurfili());
        } else {
            $arquivo .= Util::campoCnabValido($empresa->getNrinsjurempr());
        }
        
        // CAMPO: Código do Convênio no Banco   
        // POSIÇÃO: 33 a 52   
        // PICTURE: X(20) 
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        if($contcorr->getCdcedenteban()){
            $arquivo .= str_pad($contcorr->getCdcedenteban(), 20, '0', STR_PAD_LEFT);
        }else{
            $arquivo .= str_repeat('0',20);
        }
        
        // CAMPO: Agência Mantenedora da Conta    
        // POSIÇÃO: 53 a  57   
        // PICTURE: 9(5) 
        if($contcorr && $contcorr->getCdagencia())
            $arquivo .= str_pad(substr($contcorr->getCdagencia(), 0, 4), 5, '0', STR_PAD_LEFT);
        else
            $arquivo = str_pad($arquivo, 57, '0');
            
        // CAMPO: Dígito Verificador da Agência    
        // POSIÇÃO: 58 a 58    
        // PICTURE: 9(1) 
        if($contcorr){
            $arquivo .= substr($contcorr->getCdagencia(), -1);
        } else {
            $arquivo = str_pad($arquivo, 58, '0');
        }
        
        // CAMPO: Número da Conta Corrente    
        // POSIÇÃO: 59 a 70   
        // PICTURE: 9(12) 
        if($contcorr && $contcorr->getCdcontcorr()){
            $tamanho = strlen(str_replace(' ', '', $contcorr->getCdcontcorr())) - 1;
            $arquivo .= str_pad(substr(str_replace(' ', '', $contcorr->getCdcontcorr()), 0, $tamanho), 12, '0', STR_PAD_LEFT);
        }
        else
            $arquivo = str_pad($arquivo, 70, '0');

        // CAMPO: Dígito Verificador da Conta  
        // POSIÇÃO: 71 a  71  
        // PICTURE: X(1) 
        if($contcorr){
            $arquivo .= substr(str_replace(' ', '', $contcorr->getCdcontcorr()), -1);
        } else {
            $arquivo = str_pad($arquivo, 71);
        }
        
        // CAMPO: Dígito Verificador da Ag/Conta   
        // POSIÇÃO: 72 a 72 
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 72);
        
        // CAMPO: Nome da Empresa    
        // POSIÇÃO: 73 a 102 
        // PICTURE: X(30) 
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);

        if($filial){
            $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        } else {
           $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
           $nmrazsocemp = substr($nmrazsocemp, 0, 30);
           $arquivo .= str_pad($nmrazsocemp, 30); 
        }
        
        // CAMPO: Nome do Banco       
        // POSIÇÃO: 103 a 132
        // PICTURE: X(30) 
        if($contcorr){
            /** @var $banco Banco */
            $banco = Banco::findOneByCdbanco($contcorr->getCdbanco());
            if($banco){
                $nmbanco = Util::campoCnabValido($banco->getNmbanco());
                $nmbanco = substr($nmbanco, 0, 30);
                $arquivo .= str_pad($nmbanco, 30);
            }
        } else {
            $arquivo = str_pad($arquivo, 132);
        }
        
        // CAMPO: Uso Exclusivo FEBRABAN / CNAB      
        // POSIÇÃO: 133 a 142
        // PICTURE: X(10) 
        $arquivo = str_pad($arquivo, 142);
        
        /** NOTAS
         * '1' = Remessa (Cliente → Banco)
         * '2' = Retorno (Banco → Cliente)
         */
         
        // CAMPO: Código Remessa / Retorno      
        // POSIÇÃO: 143 a 143
        // PICTURE: 9(1) 
        $arquivo .= self::CODIGO_REMESSA_ARQUIVO; // REMESSA
        
        // CAMPO: Data de Geração do Arquivo       
        // POSIÇÃO: 144 a 151
        // PICTURE: 9(8) 
        $now = DateUtil::getDataDeString(DateUtil::truncateString(DateUtil::getDataAtual()));
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: Hora de Geração do Arquivo         
        // POSIÇÃO: 152 a 157
        // PICTURE: 9(6) 
        $now = DateUtil::getDataAtual();
        $horaGeracao = $now->format('His');
        $arquivo .= $horaGeracao;
        
        // CAMPO: Número Seqüencial do Arquivo         
        // POSIÇÃO: 158 a 163
        // PICTURE: 9(6) 
        $arquivo .= substr($nrseqremessarec, -6);
        
        // CAMPO: No da Versão do Layout do Arquivo          
        // POSIÇÃO: 164 a 166
        // PICTURE: 9(3) - Fixo 103
        $arquivo .= self::VERSAO_ARQUIVO;
        
        /** NOTA
         * Domínio: 1600 BPI
         * Domínio: 6250 BP
         */
         
        // CAMPO: Densidade de Gravação do Arquivo           
        // POSIÇÃO: 167 a 171 
        // PICTURE: 9(5) 
        $arquivo .= self::DENSIDADE_ARQUIVO;
        
        // CAMPO: Para Uso Reservado do Banco              
        // POSIÇÃO: 172 a 191 
        // PICTURE: X(20) 
        $arquivo = str_pad($arquivo, 191);
        
        // CAMPO: Para Uso Reservado da Empresa              
        // POSIÇÃO:  192 a 211
        // PICTURE: X(20) 
        $arquivo = str_pad($arquivo, 211);
        
        // CAMPO: Para Uso Reservado da Empresa              
        // POSIÇÃO: 212 a 240 
        // PICTURE: X(29) Brancos
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    public function geraHeaderLote($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec, $nrcnabrec, $cdreducont, $carteira = NULL, $cdfilial){

        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Banco
        // POSIÇÃO: 01 a 03
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote
        // POSIÇÃO: 04 a 07
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Registro
        // POSIÇÃO: 08 a 08
        // PICTURE: 9(1) - Fixo 1
        $arquivo .= self::TIPO_DE_REGISTRO;
        
        // CAMPO: Operação
        // POSIÇÃO: 09 a 09
        // PICTURE: X(1) Arquivo Remessa - R
        $arquivo .= self::TIPO_DE_OPERACAO;
        
        // CAMPO: Serviço
        // POSIÇÃO: 10 a 11
        // PICTURE: 9(2)  - Fixo 01  - '01' = Cobrança
        $arquivo .= self::TIPO_DE_SERVICO;
        
        // CAMPO: CNAB
        // POSIÇÃO: 12 a 13
        // PICTURE: X(2) -  Brancos
        $arquivo = str_pad($arquivo, 13);
        
        // CAMPO: Layout do Lote
        // POSIÇÃO: 14 a 16 
        // PICTURE: 9(3) Fixo 060
        $arquivo .= self::VERSAO_HEADER_LOTE;
        
        // CAMPO: CNAB
        // POSIÇÃO: 17 a 17  
        // PICTURE: X(1) - Brancos
        $arquivo = str_pad($arquivo, 17);
        
        /** Layout  Febrabam Notas 
         * '0' = Isento / Não Informado
         * '1' = CPF
         * '2' = CGC / CNPJ
         * '3' = PIS / PASEP
         * '9' = Outros
         */
        
        // CAMPO: Tipo de Inscrição da Empresa 
        // POSIÇÃO: 18 a 18  
        // PICTURE: 9(1) 
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
        
        if($empresa){
            if($empresa->getIdtpijurempr() == 'F')
                $tipoInscricaoCedente = '1';
            else
                $tipoInscricaoCedente = '2';
        }
        
        $arquivo .= $tipoInscricaoCedente;
        
        // CAMPO: Nº de Inscrição da Empresa 
        // POSIÇÃO: 19 a 33
        // PICTURE: 9(15) 
        if($filial){
            $arquivo .= str_pad($filial->getNrinsjurfili(), 15, '0', STR_PAD_LEFT);
        } else {
            $arquivo .= str_pad($empresa->getNrinsjurempr(), 15, '0', STR_PAD_LEFT);
        }
        
        // CAMPO: Código do Convênio no Banco 
        // POSIÇÃO: 34 a 53
        // PICTURE: X(20) 
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        
        if($contcorr->getCdcedenteban()){
            $arquivo .= str_pad($contcorr->getCdcedenteban(), 20, '0', STR_PAD_LEFT);
        }else{
            $arquivo .= str_repeat('0',20);
        }
        
        // CAMPO: Agência Mantenedora da Conta 
        // POSIÇÃO: 54 a 58
        // PICTURE: 9(5) 
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        
        if($contcorr && $contcorr->getCdagencia()){
            $arquivo .= str_pad(substr($contcorr->getCdagencia(), 0, 4), 5, '0', STR_PAD_LEFT);
        }else{
            $arquivo = str_pad($arquivo, 58, '0');
        }
        
        // CAMPO: Dígito Verificador da Conta 
        // POSIÇÃO: 59 a 59 
        // PICTURE: X(1) 
        if($contcorr){
            $arquivo .= substr(str_replace(' ', '', $contcorr->getCdcontcorr()), -1);
        } else {
            $arquivo = str_pad($arquivo, 59);
        }
            
        // CAMPO: Número da Conta Corrente
        // POSIÇÃO: 60 a 71 
        // PICTURE: 9(12) 
        if($contcorr && $contcorr->getCdcontcorr()){
            $tamanho = strlen(str_replace(' ', '', $contcorr->getCdcontcorr())) - 1;
            $arquivo .= str_pad(substr(str_replace(' ', '', $contcorr->getCdcontcorr()), 0, $tamanho), 12, '0', STR_PAD_LEFT);
        } else {
            $arquivo = str_pad($arquivo, 71, '0');
        }
        
        // CAMPO: Dígito Verificador da Conta
        // POSIÇÃO: 72 a 72  
        // PICTURE: X(1) 
        if($contcorr){
            $arquivo .= substr(str_replace(' ', '', $contcorr->getCdcontcorr()), -1);
        } else {
            $arquivo = str_pad($arquivo, 72);
        }
        
        // CAMPO: Dígito Verificador da Ag/Conta 
        // POSIÇÃO: 73 a 73 
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 73);
        
        // CAMPO:Nome da Empresa 
        // POSIÇÃO: 74 a 103
        // PICTURE: X(30)
        $empresa = Empresa::findOneByCdempresa($cdempresa);
        $filial = Filial::findOneByCdfilial($cdfilial);
        if($filial) {
            $nmrazsocemp = Util::campoCnabValido($filial->getNmrazsocfili());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        } else {
            $nmrazsocemp = Util::campoCnabValido($empresa->getNmrazsocempr());
            $nmrazsocemp = substr($nmrazsocemp, 0, 30);
            $arquivo .= str_pad($nmrazsocemp, 30);
        }
        
        // CAMPO:Mensagem 1  
        // POSIÇÃO: 104 a 143
        // PICTURE: X(40) 
        $arquivo = str_pad($arquivo, 143);
        
        // CAMPO:Mensagem 2  
        // POSIÇÃO: 144 a 183
        // PICTURE: X(40) 
        $arquivo = str_pad($arquivo, 183);
        
        // CAMPO:Número Remessa/Retorno   
        // POSIÇÃO: 184 a 191
        // PICTURE: 9(8) 
        $arquivo .= substr($nrcnabrec, -8);
        
        // CAMPO: Data do Crédito    
        // POSIÇÃO: 200 a 207
        // PICTURE: 9(8) 
        $now = DateUtil::getDataDeString(DateUtil::truncateString(DateUtil::getDataAtual()));
        $data = DateUtil::getDia($now) . DateUtil::getMes($now) . DateUtil::getAno($now);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: CNAB   
        // POSIÇÃO: 208 a 240 
        // PICTURE: X(33) - Brancos
        $arquivo = str_pad($arquivo, 240) . "\r\n";

        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }

    public function geraDetalheSegmentoP($caminho, $nmarquivo, $nrorg, $cdbanco, $cdempresa, $cdidrec, $nrseqremessarec,
                                                  $nrcnabrec, $idoperacao, $cdagenciacnab, $cdcontacorrente, $cdcontcorrcobranca, $nossonumero,
                                                  $idtipocobranca, $nrlanbolrec, $cdfilial, $dtvenbolrec, $valorfinalboleto, $valorpemobrec, $valormordiabrec,
                                                  $valorpemulbrec, $valormultabrec, $valorfinalbrec, $cdcartcobbol, $cddiaprotbol, $cdreducont, $imprbol,
                                                  $qtdiaprotbol, $contador = NULL
    ){
        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Código do Banco na Compensação
        // POSIÇÃO: 01 a 03
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço
        // POSIÇÃO: 04 a 07
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Tipo de Registro
        // POSIÇÃO: 08 a 08
        // PICTURE: 9(1) - Fixo 3
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;
        
        // CAMPO: Nº Sequencial do Registro no Lote 
        // POSIÇÃO:  9 a 13
        // PICTURE: 9(5) 
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);
        
        // CAMPO: Cód. Segmento do Registro Detalhe
        // POSIÇÃO:  14 a 14
        // PICTURE: X(1) - Fixo P
        $arquivo .= self::CODIGO_SEGMENTO_P;
        
        // CAMPO: CNAB
        // POSIÇÃO:  15 a 15
        // PICTURE: X(1) - Brancos
        $arquivo = str_pad($arquivo, 15);
        
        /** NOTAS
         * '01' = Entrada de Títulos             '02' = Pedido de Baixa
         * '04' = Concessão de Abatimento        '06' = Alteração de Vencimento
         *  Mais detalhes no Manual FEbrabram
         */
         
        // CAMPO: Código de Movimento Remessa 
        // POSIÇÃO: 16 a 17
        // PICTURE: 9(2) 
        if ($idoperacao and $idoperacao == 'I')
            $arquivo .= '01'; //Inclusão
        else if ($idoperacao == 'E')
            $arquivo .= '02'; // Exclusão
        else
            $arquivo .= '06'; //Alteração
            
        // CAMPO: Agência Mantenedora da Conta 
        // POSIÇÃO: 18 a 22
        // PICTURE: 9(5) 
        $contcorr = Contcorr::findOneByCdreducont($cdreducont);
        
        if($contcorr && $contcorr->getCdagencia()){
            $arquivo .= str_pad(substr($contcorr->getCdagencia(), 0, 4), 5, '0', STR_PAD_LEFT);
        }else {
            $arquivo = str_pad($arquivo, 22, '0');
        }
        
        // CAMPO: Dígito Verificador da Agência 
        // POSIÇÃO: 23 a 23 
        // PICTURE: X(1) 
        if($contcorr){
            $arquivo .= substr($contcorr->getCdagencia(), -1);
        }else {
            $arquivo = str_pad($arquivo, 23, '0');
        }
        
        // CAMPO: Número da Conta Corrente 
        // POSIÇÃO: 24 a 35 
        // PICTURE: 9(12) 
        if($contcorr && $contcorr->getCdcontcorr()){
            $tamanho = strlen(str_replace(' ', '', $contcorr->getCdcontcorr())) - 1;
            $arquivo .= str_pad(substr(str_replace(' ', '', $contcorr->getCdcontcorr()), 0, $tamanho), 12, '0', STR_PAD_LEFT);
        } else {
            $arquivo = str_pad($arquivo, 35, '0');
        }
        
        // CAMPO: Dígito Verificador da Conta 
        // POSIÇÃO: 36 a 36
        // PICTURE: X(1) 
        if($contcorr) {
            $arquivo .= substr(str_replace(' ', '', $contcorr->getCdcontcorr()), -1);
        } else {
            $arquivo = str_pad($arquivo, 36, '0');
        }
        
        // CAMPO: Dígito Verificador da Ag/Conta
        // POSIÇÃO: 37 a 37
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 37);
        
        // CAMPO: Identificação do Título no Banco - Nosso Número
        // POSIÇÃO: 38 a 57
        // PICTURE: X(20) 
        $convenio = $contcorr->getCdcedenteban();
        $arquivo .= str_pad($convenio . substr(str_replace([' ', '-'], '', $nossonumero), -8), 20);
        
        // CAMPO: Código da Carteira  
        // POSIÇÃO: 58 a 58 
        // PICTURE: 9(1) 
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        switch($boleto->getIdcartcobrec()){
            case '1':
                $arquivo .= '1';
                break;
            case '3':
                $arquivo .= '3';
                break;
            case '4':
                $arquivo .= '4';
                break;
        }
        
        // CAMPO: Forma de Cadastr. do Título no Banco  
        // POSIÇÃO: 59 a 59 
        // PICTURE: 9(1) 
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        if($boleto and $boleto->getIdformcadbrec()) {
            $arquivo .= $boleto->getIdformcadbrec();
        } else {
            $arquivo .= '1';
        }
        
        // CAMPO: Tipo de Documento   
        // POSIÇÃO: 60 a 60 
        // PICTURE: X(1) - '1' = Tradiciona
        $arquivo .= self::TIPO_DOCUMENTO;
        
        // CAMPO: Identificação da Emissão do Boleto de Pagamento   
        // POSIÇÃO: 61 a 61 
        // PICTURE: 9(1) 
        
        // CAMPO: Identificação da Distribuição   
        // POSIÇÃO: 62 a 62 
        // PICTURE: X(1)
        
        if ($imprbol == 'B' or !$nossonumero) {
            $imprimeBol = '1'; // BANCO EMITE
            $distribBol = '1';
        }
        else {
            $imprimeBol = '2'; // CLIENTE EMITE
            $distribBol = '2';
        }
        
        $arquivo .= $imprimeBol;
        $arquivo .= $distribBol;
        
        // CAMPO: Número do Documento de Cobrança    
        // POSIÇÃO: 63 a 77 
        // PICTURE: X(15) 
        $entityBoleto = Boletreceber::getRepository();
        $duplicata = $entityBoleto->getDuplicata($cdfilial, $nrlanbolrec);
        if (!$duplicata[0]['DUPLICATA']){
            $arquivo .= str_pad($nrlanbolrec, 15, '0');
        } else {
          $arquivo .= str_pad(substr($duplicata[0]['DUPLICATA'], -8),13, '0', STR_PAD_LEFT)  . str_pad($duplicata[0]['NRPARCELA'], 2, '0', STR_PAD_LEFT);
        }
        
        // CAMPO: Data de Vencimento do Título  
        // POSIÇÃO: 78 a 85
        // PICTURE: 9(8) 
        $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
        $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: Valor Nominal do Título 
        // POSIÇÃO: 86 a 100
        // PICTURE: 9(13) V(2)
        $vrfinabolrec = str_pad(($valorfinalboleto * 100), 15, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($vrfinabolrec);
        
        // CAMPO: Agência Encarregada da Cobrança 
        // POSIÇÃO: 101 a 105
        // PICTURE: 9(5)
        $arquivo = str_pad($arquivo, 105, '0');
        
        // CAMPO: Agência Encarregada da Cobrança 
        // POSIÇÃO: 101 a 105
        // PICTURE: 9(5)
        $arquivo = str_pad($arquivo, 105);
        
        // CAMPO: Dígito Verificador da Agência 
        // POSIÇÃO: 106 a 106
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 106);
        
        // CAMPO: Espécie do Título 
        // POSIÇÃO: 107 a 108 
        // PICTURE: 9(2)
        $arquivo .= self::ESPECIE_TITULO;
        
        // CAMPO: Identific. de Título Aceito/Não Aceito 
        // POSIÇÃO: 109 a 109
        // PICTURE: X(1)
        $arquivo .= self::ID_TITULO_ACEITO;
        
        // CAMPO: Data da Emissão do Título  
        // POSIÇÃO: 110 a 117
        // PICTURE: 9(8)
        $emissao = DateUtil::getDataDeString(DateUtil::truncateString($duplicata[0]['DTEMISSAO']));
        $data = DateUtil::getDia($emissao) . DateUtil::getMes($emissao) . DateUtil::getAno($emissao);
        $arquivo .= Util::campoCnabValido($data);
        
        // CAMPO: Código do Juros de Mora   
        // POSIÇÃO: 118 a 118
        // PICTURE: 9(1)
        if($valormordiabrec == 0){
            if($valorpemobrec == 0){
                $arquivo .= '3';
            } else {
                $arquivo .= '2';
            }
        } else {
            $arquivo .= '1';
        }
        
        // CAMPO: Data do Juros de Mora    
        // POSIÇÃO: 119 a 126
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 126, '0');
        
        // CAMPO:Juros de Mora por Dia/Taxa    
        // POSIÇÃO:  127 a 141 
        // PICTURE: 9(13) V(2)
        if($valormordiabrec == 0){
            if($valorpemobrec == 0) {
                $arquivo = str_pad($arquivo, 141, '0');
            } else{
                $vrpemorbrec = str_pad(($this->RemoveCaractere($valorpemobrec) * 100), 15, "0", STR_PAD_LEFT);
                $arquivo .= $vrpemorbrec;
            }
        }
        else{
            $vrmordiabrec = str_pad(($this->RemoveCaractere($valormordiabrec) * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= $vrmordiabrec;
        }
        
        // CAMPO: Código do Desconto 1      
        // POSIÇÃO: 142 a 142
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_DESCONTO;
        
        // CAMPO: Data do Desconto 1      
        // POSIÇÃO: 143 a 150
        // PICTURE: 9(8)
        $arquivo = str_pad($arquivo, 150, '0');
        
        // CAMPO: Valor/Percentual a ser Concedido       
        // POSIÇÃO:  151 a 165
        // PICTURE: 9(13) V(2)
        $arquivo = str_pad($arquivo, 165, '0');
        
        // CAMPO: Valor do IOF a ser Recolhido        
        // POSIÇÃO:  166 a 180
        // PICTURE: 9(13) V(2)
        $arquivo = str_pad($arquivo, 180, '0');
        
        // CAMPO: Valor do Abatimento        
        // POSIÇÃO:  181 a 195 
        // PICTURE: 9(13) V(2)
        $arquivo = str_pad($arquivo, 195, '0');
        
        // CAMPO: Identificação do Título na Empresa    
        // POSIÇÃO: 196  a 220
        // PICTURE: X(25)
        $arquivo .= str_pad($cdfilial.$nrlanbolrec, 25);
        
        // CAMPO: Código para Protesto   
        // POSIÇÃO: 221 a 221 
        // PICTURE: 9(1)
        
        // CAMPO: Número de Dias para Protesto 
        // POSIÇÃO: 222 a 223   
        // PICTURE: 9(2)
        
        if(!$cddiaprotbol) { 
            $diaprotbol = '3';
        } else {
            $diaprotbol = substr($cddiaprotbol, -1);
        }
        
        if(!$qtdiaprotbol) {
            $quantidadedia = '00';
        } else {
            $quantidadedia = str_pad(substr($qtdiaprotbol, -2), 2, "0", STR_PAD_LEFT);
        }
        
        if ($diaprotbol == '3' or $quantidadedia == '00') {
            $diaprotbol = '3';
            $quantidadedia = '00';
        }
        
        $arquivo .= $diaprotbol;
        $arquivo .= $quantidadedia;
        
        // CAMPO: Código para Baixa/Devolução  
        // POSIÇÃO: 224 a 224    
        // PICTURE: 9(1)
        $arquivo .= self::CODIGO_PARA_BAIXA;
        
        // CAMPO: Número de Dias para Baixa/Devolução   
        // POSIÇÃO: 225 a 227   
        // PICTURE: X(3)
        $arquivo .= self::CODIGO_PARA_BAIXA;
        
        // CAMPO: Código da Moeda  
        // POSIÇÃO: 228 a 229   
        // PICTURE: 9(2) - '09' = Real
        $arquivo .= self::CODIGO_MOEDA;
        
        // CAMPO: Nº do Contrato da Operação de Créd. 
        // POSIÇÃO: 230 a 239    
        // PICTURE: 9(10)
        $arquivo = str_pad($arquivo, 239, '0');
        
        // CAMPO: Uso livre banco/empresa ou autorização de pagamento parcial  
        // POSIÇÃO: 240 a 240    
        // PICTURE: X(1)
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    public function geraDetalheSegmentoQ($caminho, $nmarquivo, $nrorg, $cdbanco, $cdcliente, $idoperacao, $cdempresa, $cdfilial, $nrlanbolrec, $contador = NULL){
        
        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Código do Banco na Compensação
        // POSIÇÃO: 01 a 03
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço
        // POSIÇÃO: 04 a 07
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Tipo de Registro
        // POSIÇÃO: 08 a 08
        // PICTURE: 9(1) - Fixo 3
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;
        
        // CAMPO: Nº Sequencial do Registro no Lote 
        // POSIÇÃO:  9 a 13
        // PICTURE: 9(5) 
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);
        
        // CAMPO: Cód. Segmento do Registro Detalhe 
        // POSIÇÃO:  14 a 14
        // PICTURE: X(1) - Fixo Q
        $arquivo .= self::CODIGO_SEGMENTO_Q;
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB 
        // POSIÇÃO:  15 a 15 
        // PICTURE: X(1) - Brancos
        $arquivo = str_pad($arquivo, 15);
        
        // CAMPO: Código de Movimento Remessa 
        // POSIÇÃO:  16 a 17 
        // PICTURE: 9(2) 
        if ($idoperacao and $idoperacao == 'I'){
            $arquivo .= '01'; //Inclusão
        } else if ($idoperacao == 'E'){
            $arquivo .= '02'; // Exclusão
        } else {
            $arquivo .= '06'; //Alteração
        }
        
        // CAMPO: Tipo de Inscrição 
        // POSIÇÃO: 18 a 18 
        // PICTURE: 9(1) 
        
        /** @var $entityEndeClie \Geral\Repositories\Endeclie */
        // $entityEndeClie = Endeclie::getRepository();
        $endeclie = Endeclie::findOneByNrorgAndCdclienteAndIdtpendeclie($nrorg, $cdcliente, 'C');
            
        /** @var $boleto Boletreceber */
        $boleto = Boletreceber::findOneByNrlanbolrecAndCdfilial($nrlanbolrec, $cdfilial);
        /** @var $cliente Cliente */
        $cliente = Cliente::findOneByCdclienteAndNrorg($boleto->getCdcliente(), $nrorg);
        
        if($cliente->getIdtpijurclie() == 'F'){
            $tipoSacado = '1'; //CPF
        } else {
            $tipoSacado = '2'; //CNPJ
        }
        
        if($cliente->getNrinsjurclie()){
            $nrinsjur = $cliente->getNrinsjurclie();
        }
        
        if($endeclie->getNrcepclie()){
            $nrcep = $endeclie->getNrcepclie();
        } else {
            $nrcep = '00000000';
        }
        
        $nmclie = $cliente->getNmrazsocclie();
        $dsendeclie = $endeclie->getDsendeclie();
        $nmbairro = $endeclie->getNmbairclie();
        $nmmunicipio = $endeclie->getMunicipio();
        $sgestado = $endeclie->getSgestado();
            
        // CAMPO: Número de Inscrição 
        // POSIÇÃO: 19 a 33 
        // PICTURE: 9(15) 
        $arquivo .= $nrinsjur;
        
        // CAMPO: Nome 
        // POSIÇÃO: 34 a 73 
        // PICTURE: X(40) 
        $nomecliente = substr(Util::campoCnabValido($nmclie), 0, 40);
        $arquivo .= str_pad($nomecliente, 40);
        
        // CAMPO: Endereço 
        // POSIÇÃO: 74 a 113
        // PICTURE: X(40) 
        $endCliente = substr(Util::campoCnabValido($dsendeclie), 0, 40);
        $arquivo .= str_pad($endCliente, 40);
        
        // CAMPO: Bairro 
        // POSIÇÃO: 114 a 128
        // PICTURE: X(15) 
        $bairro = substr(Util::campoCnabValido($nmbairro), 0, 15);
        $arquivo .= str_pad($bairro, 15);
        
        // CAMPO: CEP  
        // POSIÇÃO: 129 a 133 
        // PICTURE: 9(15) 
        $arquivo .= Util::campoCepTel($nrcep);
        
        // CAMPO: Sufixo do CEP 
        // POSIÇÃO: 134 a 136 
        // PICTURE: 9(3) 
        $arquivo .= "000";
        
        // CAMPO: Cidade 
        // POSIÇÃO: 137 a 151 
        // PICTURE: X(15) 
        $municipio = substr(Util::campoCnabValido($nmmunicipio->getNmmunicipio()), 0, 15);
        $arquivo .= str_pad($municipio, 15);
        
        // CAMPO: Unidade da Federação 
        // POSIÇÃO: 152 a 153
        // PICTURE: X(2) 
        $arquivo .= Util::campoCnabValido($sgestado);
        
        // CAMPO: Tipo de Inscrição  
        // POSIÇÃO: 154 a 154
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 154, '0');
        
        // CAMPO: Número de Inscrição 
        // POSIÇÃO: 155 a 169  
        // PICTURE: 9(15) 
        $arquivo = str_pad($arquivo, 169, '0');
        
        // CAMPO: Nome do Sacador/Avalista 
        // POSIÇÃO: 170 a 209   
        // PICTURE: X(40) 
        $arquivo = str_pad($arquivo, 209);
        
        // CAMPO: Cód. Bco. Corresp. na Compensação 
        // POSIÇÃO: 210 a 212   
        // PICTURE: 9(3) 
        $arquivo = str_pad($arquivo, 212, '0');
        
        // CAMPO: Nosso Nº no Banco Correspondente 
        // POSIÇÃO: 213 a 232   
        // PICTURE: X(20) 
        $arquivo = str_pad($arquivo, 232);
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB 
        // POSIÇÃO: 233 a 240    
        // PICTURE: X(8) 
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    public function geraDetalheSegmentoR($caminho, $nmarquivo, $nrorg, $cdbanco, $idoperacao, $dtvenbolrec, $valorpemulbrec, $nrlanbolrec, $valormultabrec, $contador = NULL){

        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Código do Banco na Compensação
        // POSIÇÃO: 01 a 03
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço
        // POSIÇÃO: 4 a 7 
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Tipo de Registro
        // POSIÇÃO: 8 a 8
        // PICTURE: 9(1) - Fixo 3
        $arquivo .= self::TIPO_DE_REGISTRO_DETALHE;
        
        // CAMPO: Nº Sequencial do Registro no Lote
        // POSIÇÃO: 9 a 13 
        // PICTURE: 9(5)
        $contador = str_pad($contador, 5, "0", STR_PAD_LEFT);
        $arquivo .= Util::campoCnabValido($contador);
        
        // CAMPO: Cód. Segmento do Registro Detalhe
        // POSIÇÃO: 14 a 14  
        // PICTURE: X(1) - Fixo R
        $arquivo .= self::CODIGO_SEGMENTO_R;
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB
        // POSIÇÃO: 15 a 15  
        // PICTURE: X(1) - Brancos
        $arquivo = str_pad($arquivo, 15);
        
        // CAMPO: Código de Movimento Remessa 
        // POSIÇÃO: 16 a 17 
        // PICTURE: 9(2) 
        if ($idoperacao and $idoperacao == 'I'){
            $arquivo .= '01'; //Inclusão
        } else if ($idoperacao == 'E'){
            $arquivo .= '02'; // Exclusão
        } else {
            $arquivo .= '06'; //Alteração
        }  
        
        // CAMPO: Código do Desconto 2 
        // POSIÇÃO: 18 a 18
        // PICTURE: 9(1) 
        $arquivo .= self::CODIGO_DESCONTO;
        
        // CAMPO: Código do Desconto 2 
        // POSIÇÃO: 18 a 18
        // PICTURE: 9(1) 
        $arquivo = str_pad($arquivo, 18, '0');
        
        // CAMPO: Data do Desconto 2 
        // POSIÇÃO: 19 a 26 
        // PICTURE: 9(8) 
        $arquivo = str_pad($arquivo, 26, '0');
        
        // CAMPO: Valor/Percentual a ser Concedido  
        // POSIÇÃO: 27 a 41 
        // PICTURE: 9(13) V(2)  
        $arquivo = str_pad($arquivo, 41, '0');

        // CAMPO: Código do Desconto 3  
        // POSIÇÃO: 42 a 42 
        // PICTURE: 9(1)  
        $arquivo .= self::CODIGO_DESCONTO;
        
        // CAMPO: Data do Desconto 3  
        // POSIÇÃO: 43 a 50  
        // PICTURE: 9(8)  
        $arquivo = str_pad($arquivo, 50, '0');
        
        // CAMPO: Valor/Percentual a Ser Concedido   
        // POSIÇÃO: 51 a 65  
        // PICTURE: 9(13) V(2) 
        $arquivo = str_pad($arquivo, 65, '0');
        
        // CAMPO: Código da Multa   
        // POSIÇÃO: 66 a 66 
        // PICTURE: 9(1) 
        if($valorpemulbrec != '0') { 
            $arquivo .= '2';  
        } else if ($valormultabrec != '0') {
            $arquivo .= '1';  
        } else {
            $arquivo .= '0'; 
        }
        
        // CAMPO: Data da Multa  
        // POSIÇÃO: 67 a 74    
        // PICTURE: 9(8) 
        if($valormultabrec == 0 && $valorpemulbrec == 0)
            $arquivo = str_pad($arquivo, 74, '0');
        else{
            $vencimento = DateUtil::getDataDeString(DateUtil::truncateString($dtvenbolrec));
            $vencimento = DateUtil::adicionaIntervalo($vencimento, 1);
            $data = DateUtil::getDia($vencimento) . DateUtil::getMes($vencimento) . DateUtil::getAno($vencimento);
            $arquivo .= Util::campoCnabValido($data);
        }
        
        // CAMPO: Valor/Percentual a Ser Aplicado 
        // POSIÇÃO: 75 a 89    
        // PICTURE: 9(13) V(2) 
        if ($valorpemulbrec == 0){
            if ($valormultabrec == 0){
				$arquivo = str_pad($arquivo, 89, '0');
            }else{
				$vrmordiabrec = str_pad(($valormultabrec * 100), 15, "0", STR_PAD_LEFT);
				$arquivo .= Util::campoCnabValido($vrmordiabrec);
            }
        }else{
		    $vrpemorbrec = str_pad(($valorpemulbrec * 100), 15, "0", STR_PAD_LEFT);
            $arquivo .= Util::campoCnabValido($vrpemorbrec);
		}
		
        // CAMPO: Informação ao Pagador
        // POSIÇÃO: 90 a 99    
        // PICTURE: X(10) 
        $arquivo = str_pad($arquivo, 99);
        
        // CAMPO: Mensagem 3
        // POSIÇÃO:  100 a 139    
        // PICTURE: X(40) 
        $arquivo = str_pad($arquivo, 139);
        
        // CAMPO: Mensagem 4 
        // POSIÇÃO: 140 a 179    
        // PICTURE: X(40) 
        $arquivo = str_pad($arquivo, 179);
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB  
        // POSIÇÃO: 180 a 199    
        // PICTURE: X(20) 
        $arquivo = str_pad($arquivo, 199);
        
        // CAMPO: Cód. Ocor. do Pagador   
        // POSIÇÃO: 200 207     
        // PICTURE: 9(8) 
        $arquivo = str_pad($arquivo, 207, '0');
       
        // CAMPO: Cód. do Banco na Conta do Débito   
        // POSIÇÃO: 208 a 210      
        // PICTURE: 9(3) 
        $arquivo = str_pad($arquivo, 210, '0');
        
        // CAMPO: Código da Agência do Débito 
        // POSIÇÃO: 211 a 215         
        // PICTURE: 9(5) 
        $arquivo = str_pad($arquivo, 215, '0');
        
        // CAMPO: Dígito Verificador da Agência  
        // POSIÇÃO: 216 a 216          
        // PICTURE: 9(1) 
        $arquivo = str_pad($arquivo, 216, '0');
        
        // CAMPO: Conta Corrente para Débito   
        // POSIÇÃO: 217 a 228          
        // PICTURE: 9(12) 
        $arquivo = str_pad($arquivo, 228, '0');
        
        // CAMPO: Dígito Verificador da Conta   
        // POSIÇÃO: 229 a 229            
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 229, '0');
        
        // CAMPO: Dígito Verificador Ag/Conta     
        // POSIÇÃO: 230 a 230             
        // PICTURE: X(1) 
        $arquivo = str_pad($arquivo, 230, '0');
        
        // CAMPO: Aviso para Débito Automático       
        // POSIÇÃO: 231 a 231            
        // PICTURE: 9(1) 
        $arquivo = str_pad($arquivo, 231, '0');
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB      
        // POSIÇÃO: 232 a 240             
        // PICTURE: X(9) 
        $arquivo = str_pad($arquivo, 240, '0') . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    public function GeraTraillerLote($caminho, $nmarquivo, $nrorg, $cdbanco, $contador = NULL){
        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Código do Banco na Compensação 
        // POSIÇÃO:  1 a 3
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço 
        // POSIÇÃO: 4 a 7  
        // PICTURE: 9(4)
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Tipo de Registro 
        // POSIÇÃO: 8 a 8  
        // PICTURE: 9(1) - Fixo 5
        $arquivo .= self::TIPO_DE_REGISTRO_TRAILLER_LOTE;
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB  
        // POSIÇÃO: 9 a 17   
        // PICTURE: X(9) - Brancos
        $arquivo = str_pad($arquivo, 17);
        
        // CAMPO: Quantidade de Registros no Lote    
        // POSIÇÃO: 18 a 23    
        // PICTURE: 9(6)
        $arquivo .= Util::campoCnabValido(str_pad($contador + 1, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Quantidade de Títulos em Cobrança     
        // POSIÇÃO: 24 a 29     
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 29, '0');
        
        // CAMPO: Valor Total dos Títulos em Carteiras      
        // POSIÇÃO: 30 a 46      
        // PICTURE: 9(15) V(2)
        $arquivo = str_pad($arquivo, 46, '0');
        
        // CAMPO: Quantidade de Títulos em Cobrança       
        // POSIÇÃO:  47 a 52      
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 52, '0');
        
        // CAMPO: Valor Total dosTítulos em Carteiras       
        // POSIÇÃO:  53 a 69       
        // PICTURE: 9(15) V(2)
        $arquivo = str_pad($arquivo, 69, '0');
        
        // CAMPO: Quantidade de Títulos em Cobrança         
        // POSIÇÃO:  70 a 75      
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 75, '0');
        
        // CAMPO: Quantidade de Títulos em Carteiras            
        // POSIÇÃO:  76 a 92      
        // PICTURE: 9(15) V(2)
        $arquivo = str_pad($arquivo, 92, '0');
        
        // CAMPO: Quantidade de Títulos em Cobrança               
        // POSIÇÃO:  93 a 98     
        // PICTURE: 9(6)
        $arquivo = str_pad($arquivo, 98, '0');
        
        // CAMPO: Valor Total dosTítulos em Carteiras                 
        // POSIÇÃO: 99 a 115      
        // PICTURE: 9(15) V(2)
        $arquivo = str_pad($arquivo, 115, '0');
        // CAMPO: Número do Aviso de Lançamento                  
        // POSIÇÃO: 116 a 123       
        // PICTURE: X(8)
        $arquivo = str_pad($arquivo, 123);
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB                   
        // POSIÇÃO: 124 a 240       
        // PICTURE: X(117)
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);
    }
    
    public function GeraTrailler($caminho, $nmarquivo, $nrorg, $cdbanco, $contlote = NULL, $contador = NULL, $cdreducont = NULL){
        if (!is_dir($caminho))
        mkdir($caminho, "0777", true);
        $nmarquivo = $caminho.$nmarquivo;
        $file = fopen($nmarquivo, "a+");
        
        // CAMPO: Código do Banco na Compensação 
        // POSIÇÃO:  1 a 3
        // PICTURE: 9(3)
        $arquivo = self::CODIGO_BANCO;
        
        // CAMPO: Lote de Serviço 
        // POSIÇÃO:  4 a 7
        // PICTURE: 9(4)  - "9999"
        $arquivo .= self::LOTE_DO_SERVICO;
        
        // CAMPO: Tipo de Registro  
        // POSIÇÃO: 8 a 8
        // PICTURE: 9(1)  - "9"
        $arquivo .= self::LOTE_DO_SERVICO_TRAILLER;
        
        // CAMPO: Tipo de Registro  
        // POSIÇÃO: 8 a 8
        // PICTURE: 9(1)  - "9"
        $arquivo .= self::TIPO_DE_REGISTRO_TRAILLER;
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB    
        // POSIÇÃO: 9 a 17
        // PICTURE: X(1)  - "Brancos"
        $arquivo = str_pad($arquivo, 17);
        
        // CAMPO: Quantidade de Lotes do Arquivo    
        // POSIÇÃO: 18 a 23
        // PICTURE: 9(6) 
        $arquivo .= Util::campoCnabValido(str_pad($contlote, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Quantidade de Registros do Arquivo    
        // POSIÇÃO:  24 a 29
        // PICTURE: 9(6)  
        $arquivo .= Util::campoCnabValido(str_pad($contador + 1, 6, "0", STR_PAD_LEFT));
        
        // CAMPO: Qtde de Contas p/ Conc. (Lotes)   
        // POSIÇÃO: 30 a 35
        // PICTURE: 9(6)  
        $arquivo = str_pad($arquivo, 35, '0');
        
        // CAMPO: Uso Exclusivo FEBRABAN/CNAB    
        // POSIÇÃO: 36 a 240
        // PICTURE: X(205) - Brancos  
        $arquivo = str_pad($arquivo, 240) . "\r\n";
        
        //Grava a variavel arquivo no arquivo texto
        fprintf($file, "%s", $arquivo);
        fclose($file);

    }
    
    public function geraTransacao($caminho, $nmarquivo,$nrorg, $cdempresa, $cdcartcobbol, $cdagencia, $cdcontcorr, $cdfilial,
                                           $nrlanbolrec, $vrpemobrec, $idimprboleto, $cdnosnumrec, $dtvenbolrec, $cdins1cobbol,
                                           $qtdiaprotbol, $vrmordiabrec, $vrfinalbrec, $idopecnabrec, $vrpemulbrec, $idtpijurclie,
                                           $nrinsjurclie, $cdcliente, $cdins2cobbol, $contreg = NULL, $idtipcnabrec = null, $idfilialcnabrec, $cddiaprotbol = NULL, $contador = NULL,$cdreducont,$cdbanco){}
    
    public function RemoveCaractere($string){
        $pattern = "/[.,]/";
        $replacement = "";
        $result = preg_replace($pattern, $replacement, $string);
        return $result;
    }

}