<?php

namespace Teknisa\FIN\Modules\MovimentacaoBancaria\Controllers;

use Teknisa\FIN\Modules\MovimentacaoBancaria\Services\Bco21200RelacaoSaldosContaCorrenteService;
use Teknisa\FIN\Controllers\TeknisaCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Exception;


class Bco21200RelacaoSaldosContaCorrenteController extends TeknisaCrud
{
    
    protected $dataSourceName;
    protected $service;
    
    public function __construct($crudService, $parameterBag, Bco21200RelacaoSaldosContaCorrenteService $service) {   
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
    }
    
    public function findContCorrWithMasks(DTO\Request\Filter $request, DTO\Response $response)
    {
        $this->dataSourceName = 'relacao_saldos_contcorr_contcorr';
        parent::find($request, $response);
        $dataSets = $response->getDataSets();
        
       if(!empty($dataSets)){
            $rows = $dataSets[0]->getRows();
            $this->service->setMascaras($rows);
            $newDataSet = new DataSet($this->dataSourceName, $rows);
            $response->setDataSets(array($newDataSet));
        }

    }
    
    public function findRelacaoSaldosContcorr(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = 'relacao_saldos_contcorr';
        parent::find($request, $response);
        if ($response->getDataSets() && is_array($response->getDataSets())) {
            if ($response->getDataSets()[0]->getRows()) {
                $rows = $this->service->setSaldos($response->getDataSets()[0]->getRows());
                $this->service->setMascaras($rows);
                $newDataSet = new DataSet($this->dataSourceName, $rows);
                $response->setDataSets(array($newDataSet));
            }
        }
    }
    
}