<?php

namespace Teknisa\FIN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\Libs\Util\NewCode;
use Teknisa\Libs\Util\Environment;
use Teknisa\FIN\Factories\Rec57001RelatorioConciliacaoCaixaFactory;

class Rec57001RelatorioConciliacaoCaixaService {


    protected $entityManager;
    protected $relatorioConciliacaoCaixaService;
    protected $nrorg;
    protected $newCode;
  
    function __construct(EntityManager $entityManager, Environment $environment, Rec57001RelatorioConciliacaoCaixaFactory $relatorioConciliacaoCaixaFactory, NewCode $newCode){
        $this->entityManager          = $entityManager;
        $this->Rec57001RelatorioConciliacaoCaixaFactory = $relatorioConciliacaoCaixaFactory;
        $this->newCode                   = $newCode;
        $this->nrorg = $environment->getNrOrgTrab();
    }
    
    function execProcRecConCaixa($dados) {
      try {
          $nrseqconctemp = $this->newCode->getCodeByTableName('CONCCAIXA_TEMP', $this->nrorg, 1, 5);
          
          $paramProcedure = array(
               "P_NRSEQCONCTEMP"   => $nrseqconctemp,
               "P_CDEMPRESA"       => $dados["P_CDEMPRESA"],
               "P_DATAINICIAL"     => $dados["P_DATAINICIAL"],
               "P_DATAFINAL"       => $dados["P_DATAFINAL"],
            );
            
           $retorno = $this->Rec57001RelatorioConciliacaoCaixaFactory->execProcRecConCaixa($paramProcedure);
           
           return $nrseqconctemp;
           
      }catch(\Exception $e) {
        return ($e->getMessage());
      }
    }
}