var Rec18000_Compensacao_Conta_Receber = function(ScreenService, templateManager, General, Rec18000_CompensacaoContaReceber_Service, ZHPromise, ZhFilterPreferences){

    var wasFiltered = false;

    this.openFilterCompensacaoReceber = function(compensacaoContasReceber){
        var data = moment().format('DD/MM/YYYY');
        var rowFilter = {'DTCOMPCONTREC': {start : data, end : data}};
        this.setDefaultValueFromFilter().then(function(filialLogada){
            rowFilter.CDFILIAL = filialLogada.CDFILIAL;
            rowFilter.NRORG    = filialLogada.NRORG;
            ZhFilterPreferences.setOriginalFilter(compensacaoContasReceber.id, rowFilter);
            ZhFilterPreferences.openFilterWidget(compensacaoContasReceber, rowFilter); 
        });
    };
    
    this.setDefaultValueFromFilter = function (){
        var deferred = ZHPromise.defer();
        Rec18000_CompensacaoContaReceber_Service.getFilialLogada().then(function(filialLogada) {
            deferred.resolve(filialLogada[0]);
        });
        return deferred.promise;
    };

    this.getDefaulInterval = function (){
        var obj = {
            "start": moment().startOf('month').format('DD/MM/YYYY'),
            "end": moment().endOf('month').format('DD/MM/YYYY')
        };
        return obj;
    };

    this.getCurrentField = function(widgetName, fieldName) {
        return General.getFieldValue(fieldName,widgetName);
    };

    this.validaDatasBaixaCompensacao = function(widget, fieldClear){
        var arrayBaixa = widget.currentRow.DTBAIXACOMP.split('/');
        var arrayComp = widget.currentRow.DTCOMPENCTPAG.split('/');
        var anoBaixa = arrayBaixa.pop();
        var mesBaixa = arrayBaixa.pop();
        var diaBaixa = arrayBaixa.pop();
        var anoComp = arrayComp.pop();
        var mesComp = arrayComp.pop();
        var diaComp = arrayComp.pop();
        var dataBaixa = parseInt(anoBaixa.concat(mesBaixa.concat(diaBaixa)));
        var dataCompensacao = parseInt(anoComp.concat(mesComp.concat(diaComp)));
        if (dataBaixa <= dataCompensacao){
            ScreenService.showMessage('Data da baixa deve ser igual ou maior à data da compensação.');
            fieldClear.setValue('');
        }
    };

    this.adicionaCompensacao = function(widget){
        this.novaCompensacao(widget).then(function(){
            this.validaItemCompensacao(widget);
        }.bind(this));
    };

    this.novaCompensacao = function(widget){
        var deferred = ZHPromise.defer();
        General.widgetNewRow(widget);
        widget.getField('IDTPITUTLCOMREC').setValue('0');
        widget.getField('CONTAPAGAR').isVisible = true;
        widget.getField('CONTACORRENTE').isVisible = true;
        widget.getField('CONTARECEBER').isVisible = true;
        widget.getField('VRTOTALCOMREC').class = '3';
        widget.getField('SOMACONTACORRENTE').class = '3';
        templateManager.container.getWidget('TitulosCompensadosPagar').isVisible = false;
        templateManager.container.getWidget('ContasCorrentesCompensadas').isVisible = false;
        deferred.resolve();
        return deferred.promise;
    };

    this.cancelaCompensacao = function(widget){
        General.widgetCancelForm(widget);
        widget.getField('CONTAPAGAR').isVisible = false;
        widget.getField('CONTACORRENTE').isVisible = false;
        widget.getField('CONTARECEBER').isVisible = false;
        widget.getField('VRTOTALCOMREC').class = '12';
        widget.getField('SOMACONTACORRENTE').class = '12';
        templateManager.container.getWidget('TitulosCompensadosPagar').isVisible = true;
        templateManager.container.getWidget('ContasCorrentesCompensadas').isVisible = true;
    };

    this.ativaFiltroContasPagar = function (args) {
        if (!wasFiltered) {
            var filtroContaPagar = templateManager.container.getWidget('filtroContaPagar');
            ScreenService.openPopup(filtroContaPagar).then(function () {
                filtroContaPagar.activate();
            });
            args.e.preventDefault();
        } else {
            wasFiltered = false;
        }
    };

    this.aplicaFiltroCompensacaoReceber = function () {
        var compensacao = templateManager.container.getWidget('CompensacaoContasReceber');
        var filtro = compensacao.appliedFilter;
        var operador = '';
        var cdforneced = '';
        var lancIni = filtro.FILTER_ROW.DTLANCCOMPREC.start;
        var lancFin = filtro.FILTER_ROW.DTLANCCOMPREC.end;
        var compIni = filtro.FILTER_ROW.DTCOMPENCTREC.start;
        var compFin = filtro.FILTER_ROW.DTCOMPENCTREC.end;
        var operadorMulti = filtro.FILTER_ROW.CDOPERADOR;
        var fornecedorMulti = filtro.FILTER_ROW.CDCLIENTE;
        if (operadorMulti) {
            operadorMulti.forEach(function (filter) {
                operador += "_" + filter;
            });
            operador += "_";
        }
        if (fornecedorMulti) {
            fornecedorMulti.forEach(function (filter) {
                cdforneced += "_" + filter;
            });
            cdforneced += "_";
        }
        compensacao.dataSourceFilter.forEach(function (data) {
            switch (data.name) {
                case 'CDEMPRESA':
                    data.value = filtro.FILTER_ROW.CDEMPRESA;
                    break;
                case 'CDOPERADOR':
                    data.value = operador;
                    break;
                case 'TCDOPERADOR':
                    data.value = (operador) ? null : 'T';
                    break;
                case 'CDCLIENTE':
                    data.value = cdforneced;
                    break;
                case 'TCDCLIENTE':
                    data.value = (cdforneced) ? null : 'T';
                    break;
                case 'DTCOMPENSACAO_INI': data.value = compIni;
                    break;
                case 'DTCOMPENSACAO_FIN': data.value = compFin;
                    break;
                case 'TCOMPENSACAO': data.value = (compIni && compFin) ? null : 'T';
                    break;
                case 'DTLANCAMENTO_INI': data.value = lancIni;
                    break;
                case 'DTLANCAMENTO_FIN': data.value = lancFin;
                    break;
                case 'TLANCAMENTO': data.value = (lancIni && lancFin) ? null : 'T';
                    break;
            }
        });
    };

    this.validaItemCompensacao = function (widget) {
        if (widget.currentRow.IDTPITUTLCOMREC == '0') {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == 'contaPagar') {
                    group.isVisible = true;
                    widget.getField('CONTACORRENTE').validations = null;
                    widget.getField('CONTAPAGAR').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('NMTPBAIXAPAG').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('DSAJUCTPAG').validations = {'required': {'message': 'Campo obrigatório'}};
                }
                if (group.name == 'creditoContaCorrente') {
                    group.isVisible = false;
                }
            });
        } else {
            widget.fieldGroups.forEach(function (group) {
                if (group.name == 'contaPagar') {
                    group.isVisible = false;
                }
                if (group.name == 'creditoContaCorrente') {
                    group.isVisible = true;
                    widget.getField('CONTACORRENTE').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('CONTAPAGAR').validations = null;
                    widget.getField('NMTPBAIXAPAG').validations = null;
                    widget.getField('DSAJUCTPAG').validations = null;
                }else{
                    widget.getField('CONTACORRENTE').validations = null;
                    widget.getField('CONTAPAGAR').validations = widget.getField('CONTAPAGAR').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('NMTPBAIXAPAG').validations = widget.getField('NMTPBAIXAPAG').validations = {'required': {'message': 'Campo obrigatório'}};
                    widget.getField('DSAJUCTPAG').validations = widget.getField('DSAJUCTPAG').validations = {'required': {'message': 'Campo obrigatório'}};
                }
            });
        }
    };

    this.validaTipoCompensacao = function(widget){
        var titulosCompensados = templateManager.container.getWidget('TitulosCompensadosPagar');
        var contasCompensadas = templateManager.container.getWidget('ContasCorrentesCompensadas');
        if (widget.currentRow.IDTPITUTLCOMREC == '0'){
            titulosCompensados.isVisible = true;
            titulosCompensados.enabled = true;
            contasCompensadas.isVisible = false;
            this.setFiltroTitulosPagCompensados(widget, titulosCompensados).then(function(){
                titulosCompensados.reload();
            });
        }else{
            contasCompensadas.isVisible = true;
            contasCompensadas.enabled = true;
            titulosCompensados.isVisible = false;
            this.setFiltroContasCorrentesCompensadas(widget, contasCompensadas).then(function(){
                contasCompensadas.reload();
            });
        }
    };

    this.setFiltroTitulosPagCompensados = function (widget, pagarCompensados) {
        var deferred = ZHPromise.defer();
        pagarCompensados.dataSourceFilter.forEach(function (data) {
            switch(data.name) {
                case 'NRLANCCOMPREC': data.value = widget.currentRow.NRLANCCOMPREC;
                    break;
                case 'CDEMPRESA': data.value = widget.currentRow.CDEMPRESA;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.setFiltroContasCorrentesCompensadas = function (widget, contasCompensadas) {
        var deferred = ZHPromise.defer();
        contasCompensadas.dataSourceFilter.forEach(function (data) {
            switch(data.name) {
                case 'NRLANCCOMPREC': data.value = widget.currentRow.NRLANCCOMPREC;
                    break;
                case 'NRORG': data.value = widget.currentRow.NRORG;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.getEmpresa = function(){
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.CDEMPRESA;
    };

    this.getFilial = function(){
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.CDFILIAL;
    };

    this.getNrorg = function(){
        return templateManager.container.getWidget('CompensacaoContasReceber').currentRow.NRORG;
    };



    this.validaCamposAtivos = function (args){
        var field = args.owner.field.name;
        var row;
        switch(field) {
            case 'NMEMPRESA':
                row = args.owner.field.widget.currentRow;
                args.owner.field.widget.getField('NMRAZSOCCLIE').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('NMTPBAIXAPAG').readOnly = !row.NMEMPRESA;
                args.owner.field.widget.getField('DSAJUCTPAG').readOnly = !row.NMEMPRESA;
                break;
            case 'NMRAZSOCCLIE':
                row = args.owner.field.widget.currentRow;
                args.owner.field.widget.getField('CONTARECEBER').readOnly = !row.NMRAZSOCCLIE;
                break;
            case 'CDREDUCONT':
                row = args.owner.field.widget.currentRow;
                args.owner.field.widget.getField('CONTACORRENTE').readOnly = !row.CDREDUCONT;
                break;
            default:
                var aux = 'teste';
        }
    };

    this.validaFieldLancContaCorrente = function (args){
        var field = args.owner.field.name;

        switch(field) {
            case 'CDREDUCONT':
                var row = args.owner.field.widget.currentRow;
                args.owner.field.widget.getField('CONTACORRENTE').readOnly = !row.CDREDUCONT;
                break;
            default:
                var aux = 'teste';
        }
    };

    this.saveCompensacao = function (widget) {
        var route = 'fin_contaReceber#/saveCompensacaoCobranca';
        var dataSet = [];
        var valorCompensar = 0;

        if (widget.isValid())
        {
            dataSet = this.preparaRowCompensacaoReceber(widget, dataSet);
            var valorContaReceber = parseFloat(widget.currentRow.VRFINALBREC);
            //Verifica se compensa com lançamentos em conta ou contas a receber.
            if (widget.currentRow.IDTPITUTLCOMREC == '0') {
                valorCompensar = parseFloat(widget.currentRow.VRTOTALCOMREC);
                dataSet = this.preparaRowContasPagar(widget, dataSet);
            } else {
                valorCompensar = parseFloat(widget.currentRow.SOMACONTACORRENTE);
                dataSet = this.preparaRowLancamentoPagar(widget, dataSet);
            }
            if (valorCompensar != '0'){
                if (valorCompensar <= valorContaReceber){
                    General.callRestEngine(route, 'DataSet', dataSet)
                    .then(
                        function () {
                            widget.getField('CONTARECEBER').isVisible = false;
                            widget.getField('CONTAPAGAR').isVisible = false;
                            widget.getField('CONTACORRENTE').isVisible = false;
                            widget.getField('NMRAZSOCCLIE').readOnly = true;
                            widget.getField('VRTOTALCOMREC').class = '12';
                            widget.getField('SOMACONTACORRENTE').class = '12';
                            ScreenService.closeSwipe().then(function(){
                                widget.reload();
                                ScreenService.showMessage('Registro salvo com sucesso!');
                            });
                        }
                    )
                    .catch(
                        function(erro){
                            ScreenService.showMessage(erro.data.error);
                        }
                    );
                }else{
                    ScreenService.showMessage("Valor total a compensar deve ser menor ou igual ao valor líquido da conta informada.");
                }
            }else{
                ScreenService.showMessage("Valor total a compensar deve ser maior que zero.");
            }
        }
    };

    this.preparaRowCompensacaoReceber = function (widget, dataSetPagar) {
        dataSetPagar[0] = widget.currentRow;
        if (widget.currentRow.IDTPITUTLCOMREC == '0') {
            //Dados Conta Receber
            dataSetPagar[0].VRTOTALCOMREC = widget.currentRow.VRTOTALCOMREC;
            dataSetPagar[0].DSBAIXAPAG = widget.currentRow.NMTPBAIXAPAG;
        } else {
            //Dados Conta Receber
            dataSetPagar[0].VRTOTALCOMREC = widget.currentRow.SOMACONTACORRENTE;
        }
        return dataSetPagar;
    };

    this.preparaRowContasPagar = function (widget, dataSet) {
        var contaPagar = templateManager.container.getWidget('CompensacaoContasReceber').getField('CONTAPAGAR');
        contaPagar.dataSource.getCheckedRows().forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = data;
            dataSet[indice].CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
            dataSet[indice].CDEMPRESA = widget.currentRow.CDEMPRESA;
        });

        return dataSet;
    };

    this.preparaRowLancamentoPagar = function (widget, dataSet) {
        var contaCorrente = templateManager.container.getWidget('CompensacaoContasReceber').getField('CONTACORRENTE');
        contaCorrente.dataSource.getCheckedRows().forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = data;
            dataSet[indice].VRTOTALCOMREC = data.SOMACONTACORRENTE;
            dataSet[indice].CDAJUCTPAG = widget.currentRow.CDAJUCTPAG;
            dataSet[indice].CDTPBAIXAPAG = widget.currentRow.CDTPBAIXAPAG;
        });
        return dataSet;
    };


    this.filtraContasPagar = function (filtroContasPagar) {
        var compensacaoPagar = filtroContasPagar.getParent();
        var contaPagar = compensacaoPagar.getField('CONTAPAGAR');
        ScreenService.closePopup(false);
        wasFiltered = true;
        this.aplicaFiltroContasPagar(filtroContasPagar, contaPagar).then(function () {
            contaPagar.reload();
            $("#CONTAPAGAR").scope().openField(contaPagar);
        });
    };

    this.aplicaFiltroContasPagar = function (filtroContasPagar, contaPagar) {
        var deferred = ZHPromise.defer();
        var compensacaoPagar = filtroContasPagar.getParent();

        var fornecedorConcat = '';
        var cdfiliemit = '';
        var cdfilial = '';
        if (filtroContasPagar.currentRow.FORNECEDORFILTRO){
            if (filtroContasPagar.currentRow.FORNECEDORFILTRO.length > 0){
                filtroContasPagar.currentRow.FORNECEDORFILTRO.forEach(function (value) {
                    fornecedorConcat += "_" + value;
                });
                fornecedorConcat = (fornecedorConcat) ? fornecedorConcat + "_" : null;
            }else{
               fornecedorConcat = null;
           }
        }else{
            fornecedorConcat = null;
        }
        if (Array.isArray(filtroContasPagar.getField('CDFILIEMIT').value())) {
            filtroContasPagar.getField('CDFILIEMIT').value().forEach(function (data) {
                cdfiliemit += '_' + data;
            });
            cdfiliemit = (cdfiliemit) ? cdfiliemit + "_" : null;
        }
        if (Array.isArray(filtroContasPagar.getField('CDFILIALANC').value())) {
            filtroContasPagar.getField('CDFILIALANC').value().forEach(function (data) {
                cdfilial += '_' + data;
            });
            cdfilial = (cdfilial) ? cdfilial + "_" : null;
        }
        var valorIni = (filtroContasPagar.getField('VRFINALBPAG_INI').value() === undefined)? null : filtroContasPagar.getField('VRFINALBPAG_INI').value();
        var valorFin = (filtroContasPagar.getField('VRFINALBPAG_FIN').value() === undefined)? null : filtroContasPagar.getField('VRFINALBPAG_FIN').value();
        contaPagar.dataSourceFilter.forEach(function (filtro) {
            switch (filtro.name) {
                case 'CDEMPRESA':
                    filtro.value = (compensacaoPagar.currentRow.CDEMPRESA) ? compensacaoPagar.currentRow.CDEMPRESA : null;
                    break;
                case 'CDFORNECED':
                    filtro.value = fornecedorConcat;
                    break;
                case 'DOCINICIAL':
                    filtro.value = filtroContasPagar.getField('DOCINICIAL').value();
                    break;
                case 'DOCFINAL':
                    filtro.value = filtroContasPagar.getField('DOCFINAL').value();
                    break;
                case 'FILIORIG':
                    filtro.value = cdfiliemit;
                    break;
                case 'FILILANC':
                    filtro.value = cdfilial;
                    break;
                case 'DATAINI':
                    filtro.value = filtroContasPagar.getField('DTVENBOLPAG').value().start;
                    break;
                case 'DATAFIN':
                    filtro.value = filtroContasPagar.getField('DTVENBOLPAG').value().end;
                    break;
                case 'CDTPBAIXAPAG':
                    filtro.value = filtroContasPagar.currentRow.TIPOBAIXAPAGAR;
                    break;
                case 'VALORINI':
                    filtro.value = valorIni;
                    break;
                case 'VALORFIN':
                    filtro.value = valorFin;
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    /*
     * INICIO - GERA BAIXA PLANEJADA
     */

    this.deleteCompensacao = function (widget) {
        var route = 'fin_contaReceber#/deleteCompensacaoCobranca';
        var dataSet = [];
        dataSet = this.preparaRowDeleteCompensacao(widget, dataSet);
        if (widget.currentRow.IDTPITUTLCOMREC == '0'){
            var widgetTitulos = templateManager.container.getWidget('TitulosCompensadosPagar');
            this.preparaRowDeleteTitulos(widgetTitulos, dataSet);
        }else{
            var widgetContas = templateManager.container.getWidget('ContasCorrentesCompensadas');
            this.preparaRowDeleteContas(widgetContas, dataSet);
        }
        ScreenService.confirmMessage(ScreenService.i18n('Deseja excluir Compensação?'), 'question', function () {
            General.callRestEngine(route, 'DataSet', dataSet)
                .then(function () {
                    ScreenService.closeSwipe().then(function(){
                        widget.reload();
                        ScreenService.showMessage('Registro excluído com sucesso!');
                    });
                })
                .catch(function (response) {
                    ScreenService.showMessage(response.data.error);
                });
        });
    };

    this.preparaRowDeleteCompensacao = function(widget, dataSet){
        var indice = dataSet.length;
        dataSet[indice] = widget.currentRow;
        return dataSet;
    };

    this.preparaRowDeleteTitulos = function(widget, dataSet){
        widget.dataSource.data.forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = data;
        });
        return dataSet;
    };

    this.preparaRowDeleteContas = function(widget, dataSet){
        widget.dataSource.data.forEach(function(data){
            var indice = dataSet.length;
            dataSet[indice] = {};
            dataSet[indice].CDREDUCONT = data.CDREDUCONT;
            dataSet[indice].NRMOVICRED = data.NRMOVICRED;
        });
        return dataSet;
    };

    this.ativaFiltroContaCorrente = function (args) {
        if (!wasFiltered) {
            var filtroContaCorrente = templateManager.container.getWidget('filtroContaCorrente');
            ScreenService.openPopup(filtroContaCorrente).then(function () {
                filtroContaCorrente.activate();
            });
            args.e.preventDefault();
        }
        else {
            wasFiltered = false;
        }
    };

    this.filtraContaCorrente = function (filtroContaCorrente) {
        var compensacaoReceber = filtroContaCorrente.getParent();
        var contaCorrente = compensacaoReceber.getField('CONTACORRENTE');
        ScreenService.closePopup(false);
        wasFiltered = true;
        this.aplicaFiltroContaCorrente(filtroContaCorrente, contaCorrente).then(function () {
            contaCorrente.reload();
            $("#CONTACORRENTE").scope().openField(contaCorrente);
        });
    };

    this.aplicaFiltroContaCorrente = function (filtroContaCorrente, contaCorrente) {
        var deferred = ZHPromise.defer();
        var compensacaoPagar = filtroContaCorrente.getParent();
        var dataInicial, dataFinal, valorInicial, valorFinal = null;
        var tipoCredito = '';
        if (filtroContaCorrente.currentRow.TIPOCREDITO){
            filtroContaCorrente.currentRow.TIPOCREDITO.forEach(function (value) {
                tipoCredito += "_" + value;
            });
            tipoCredito = (tipoCredito) ? tipoCredito + "_" : null;
        }
        var contas = '';
        if (!filtroContaCorrente.CONTAFILTRO) {
            if (filtroContaCorrente.currentRow.hasOwnProperty('CONTAFILTRO') &&
                filtroContaCorrente.currentRow.CONTAFILTRO.length > 0){
                filtroContaCorrente.currentRow.CONTAFILTRO.forEach(function (value) {
                    contas += "_" + value;
                });
                contas = (contas) ? contas + "_" : null;
            }else{
                contas = [];
            }
        }else{
            contas = [];
        }
        contaCorrente.dataSourceFilter.forEach(function (data) {
            switch (data.name) {
                case 'CDEMPRESA':
                    data.value = compensacaoPagar.currentRow.CDEMPRESA;
                    break;
                case 'CDREDUCONT':
                    data.value = (contas.length != 0) ? contas : null;
                    break;
                case 'TCDREDUCONT':
                    data.value = (contas.length != 0) ? null : 'T';
                    break;
                case 'DATAINICIAL':
                    dataInicial = (filtroContaCorrente.currentRow.DATALANCAMENTO.start) ? filtroContaCorrente.currentRow.DATALANCAMENTO.start : null;
                    data.value = dataInicial;
                    break;
                case 'DATAFINAL':
                    dataFinal = (filtroContaCorrente.currentRow.DATALANCAMENTO.end) ? filtroContaCorrente.currentRow.DATALANCAMENTO.end : null;
                    data.value = dataFinal;
                    break;
                case 'TDATA':
                    data.value = (dataInicial && dataFinal) ? null : 'T';
                    break;
                case 'VALORINICIAL':
                    valorInicial = (filtroContaCorrente.currentRow.VALORINICIAL) ? filtroContaCorrente.currentRow.VALORINICIAL : null;
                    data.value = valorInicial;
                    break;
                case 'VALORFINAL':
                    valorFinal = (filtroContaCorrente.currentRow.VALORFINAL) ? filtroContaCorrente.currentRow.VALORFINAL : null;
                    data.value = valorFinal;
                    break;
                case 'TVALOR':
                    if (valorInicial && valorFinal) {
                        if (valorInicial == 0 && valorFinal == 0) {
                            data.value = 'T';
                        } else {
                            data.value = null;
                        }
                    } else {
                        data.value = 'T';
                    }

                    break;
                case 'CDTPCREDBANC':
                    data.value = (tipoCredito) ? tipoCredito : null;
                    break;
                case 'TTIPO':
                    data.value = (tipoCredito) ? null : 'T';
                    break;
            }
        });
        deferred.resolve();
        return deferred.promise;
    };

    this.setTodasContasCorrentes = function (value) {
        var filtroContaCorrente = templateManager.container.getWidget('filtroContaCorrente');
        filtroContaCorrente.CONTAFILTRO = value;
    };

    this.somaValorCompensarContaCorrente = function (contaCorrente) {
        var compensacao = templateManager.container.getWidget('CompensacaoContasReceber');
        var valorCompensar = 0;
        if (compensacao.isActive()){
            contaCorrente.value().forEach(function (data) {
                valorCompensar += parseFloat(data);
            });
        }else{
            contaCorrente.dataSource.getCheckedRows().forEach(function (data) {
                valorCompensar += parseFloat(data.VRMOVICRED);
            });
        }
        compensacao.currentRow.SOMACONTACORRENTE = valorCompensar;
        compensacao.activate();
    };

    this.somaValorCompensarContasReceber = function (contaPagar) {
        var compensacao = templateManager.container.getWidget('CompensacaoContasReceber');
        var valorCompensar = 0;
        if (compensacao.isActive()){
            contaPagar.value().forEach(function (data) {
                valorCompensar += parseFloat(data);
            });
        }else{
            contaPagar.dataSource.getCheckedRows().forEach(function (data) {
                valorCompensar += parseFloat(data.VRFINALBPAG);
            });
        }
        compensacao.currentRow.VRTOTALCOMREC = valorCompensar;
        compensacao.activate();
    };

    this.cancelarFiltro = function () {
        ScreenService.closePopup();
        templateManager.container.getWidget('CompensacaoContasReceber').activate();
    };
    
    this.atualizaContaCorrente = function() {
       var contaCorrente =  templateManager.container.getWidget('CompensacaoContasReceber').getField('CDREDUCONT');
       contaCorrente.setValue("");
       contaCorrente.reload();
    };

};

Configuration(function (ContextRegister){
    ContextRegister.register('Rec18000_Compensacao_Conta_Receber', Rec18000_Compensacao_Conta_Receber);
});