function Bco31000_FluxoCaixa_Controller(ZhFilterPreferences, templateManager) {
    
    /**
     * Variáveis de Inicialização
     **/

    var self = this;
    
    /**
     * Abertura do Filtro de Relatório
     * @param widget 
     */

    self.openFilterRelatorio = function(widget){
        ZhFilterPreferences.openFilterWidget(widget);
    };
    
     this.dataSource = function(widget,preference){
        var grid =  templateManager.container.getWidget('fluxo_caixa_diario_mensal');
        if(grid.getField('IDRELATORIO').value() == 'D'){
            grid.dataSource.name = 'fin_movimentacaoBancaria#/crud/fluxo_de_caixa_diario';
        }else{
            grid.dataSource.name = 'fin_movimentacaoBancaria#/crud/fluxo_de_caixa_mensal';
        }
     };
     

    self.filterRelatorio = function(widget, preference){
        var grid =  templateManager.container.getWidget('fluxo_caixa_diario_mensal');
        var idRelatorio = preference.FILTER_ROW.IDRELATORIO;
        
        var cdEmpresa = preference.FILTER_ROW.CDEMPRESA;
        var cdClassfina = preference.FILTER_ROW.CDCLASSFINA;
        var tcdclassfina = preference.FILTER_ROW.TCDCLASSFINA;
        var cdFilial = preference.FILTER_ROW.CDFILIAL;
        var tcdFilial = preference.FILTER_ROW.TCDFILIAL;
        var dtmes = preference.FILTER_ROW.DTMES;
        var saldoIni = preference.FILTER_ROW.SALDOINI;
        var dtMovFluxo = preference.FILTER_ROW.DTMOVFLUXO;
        var idmovfluxo = preference.FILTER_ROW.IDMOVFLUXO;
        var fluxo;
        
        if(cdFilial === undefined || cdFilial.length === 0){
            tcdFilial = 'T';
        }else{
            tcdFilial = '';
        }
        
        if(cdClassfina === undefined || cdClassfina.length === 0){
            tcdclassfina = 'T';
        }else{
            tcdclassfina = '';
        }
        
        if(Array.isArray(idmovfluxo)){
            fluxo = idmovfluxo.join("_");
        }else{
            fluxo = idmovfluxo;
        }
        
        if(idRelatorio == 'D'){
            grid.dataSource.name = 'fin_movimentacaoBancaria#/crud/fluxo_de_caixa_diario';
            widget.dataSourceFilter.splice(0,1);
            let filtroDiario= [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "CDCLASSFINA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TCDCLASSFINA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TCDFILIAL",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "IDMOVFLUXO",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "DTMOVFLUXO",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "DTINICIAL",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "SALDOINI",
                        "operator": "=",
                        "value": null
                    }
                ];
                
            widget.dataSourceFilter = filtroDiario;
        
            widget.dataSourceFilter.forEach(function(filtro) {
                switch (filtro.name) {
                    case 'CDEMPRESA':
                        filtro.value = cdEmpresa?cdEmpresa.join("_"): 'T';
                    break;
                    case 'CDCLASSFINA':
                        filtro.value = cdClassfina?cdClassfina.join("_"):null;
                    break;
                    case 'TCDCLASSFINA':
                        filtro.value = tcdclassfina?tcdclassfina:null;
                    break;
                    case 'CDFILIAL':
                        filtro.value = cdFilial?cdFilial.join("_"):null;
                    break;
                    case 'TCDFILIAL':
                        filtro.value = tcdFilial?tcdFilial:null;
                    break;
                    case 'DTMOVFLUXO':
                        filtro.value = dtMovFluxo?dtMovFluxo.end:'';
                    break;
                    case 'DTINICIAL':
                        filtro.value = dtMovFluxo?dtMovFluxo.start:'';
                    break;
                    case 'SALDOINI':
                        filtro.value = saldoIni?saldoIni:'';
                    break;
                    case 'IDMOVFLUXO':
                        filtro.value = idmovfluxo?fluxo:'';
                    break;
                }
            });
            preference.CUSTOM_FILTER_ROW = {};
        }else{
            grid.dataSource.name = 'fin_movimentacaoBancaria#/crud/fluxo_de_caixa_mensal';
            widget.dataSourceFilter.splice(0,1);
            let filtroMensal = [
                    {
                        "name": "CDEMPRESA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "CDCLASSFINA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TCDCLASSFINA",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "TCDFILIAL",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "IDMOVFLUXO",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "DTINICIAL",
                        "operator": "=",
                        "value": "@getLocalVar('DTMOVFLUXO')@"
                    },
                    {
                        "name": "SALDOINI",
                        "operator": "=",
                        "value": null
                    },
                    {
                        "name": "DTMES",
                        "operator": "=",
                        "value": null
                    }
                ];
                
            widget.dataSourceFilter = filtroMensal;
        
            widget.dataSourceFilter.forEach(function(filtro) {
                switch (filtro.name) {
                    case 'CDEMPRESA':
                        filtro.value = cdEmpresa?cdEmpresa.join("_"): 'T';
                    break;
                    case 'CDCLASSFINA':
                        filtro.value = cdClassfina?cdClassfina.join("_"):null;
                    break;
                    case 'TCDCLASSFINA':
                        filtro.value = tcdclassfina?tcdclassfina:null;
                    break;
                    case 'CDFILIAL':
                        filtro.value = cdFilial?cdFilial.join("_"):null;
                    break;
                    case 'TCDFILIAL':
                        filtro.value = tcdFilial?tcdFilial:null;
                    break;
                    case 'DTMES':
                        filtro.value = dtmes?dtmes:'';
                    break;
                    case 'DTINICIAL':
                        filtro.value = dtmes?dtmes:'';
                    break;
                    case 'SALDOINI':
                        filtro.value = saldoIni?saldoIni:'';
                    break;
                    case 'IDMOVFLUXO':
                        filtro.value = idmovfluxo?fluxo:'';
                    break; 
                }
            });
            preference.CUSTOM_FILTER_ROW = {};
        }
        
    };

    this.controlaVisualizacaoGrid = function(valueReport, widget) {
           var grid =  templateManager.container.getWidget('fluxo_caixa_diario_mensal');
           var report = valueReport.owner.field.value();
           var dtmes = widget.getField('DTMES');
           var dtMovFluxo = widget.getField('DTMOVFLUXO');
           var vrsaldoacum = grid.getField('VRSALDOACUM');
        //   var saldoacum = grid.getField('SALDOACUM');
           var saldo = grid.getField('SALDO');
           if (report == 'D') {
               vrsaldoacum.isVisible =  false;
            //   saldoacum.isVisible =  true;
               saldo.isVisible =  true;
               dtMovFluxo.isVisible = true;
               dtmes.isVisible =  false;
               dtMovFluxo.setValue("");
              // dtMovFluxo.validations = {"required": true};
               dtMovFluxo.isVisibleOnReport = true;
           } else {
             vrsaldoacum.isVisible =  true;
            // saldoacum.isVisible =  false;
             saldo.isVisible =  false;
             dtMovFluxo.isVisible = false;
             dtmes.isVisible =  true;
             dtmes.setValue("");
             dtmes.validations = {"required": true};
             dtmes.isVisibleOnReport = true;
           }
            widget.reload();
   };
    
}
Configuration(function (ContextRegister) {
	ContextRegister.register('Bco31000_FluxoCaixa_Controller', Bco31000_FluxoCaixa_Controller);
});