package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.dbsteps.UsuariosDBSteps;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.flows.TipoDeDespesasFlows;
import com.javaseleniumtemplate.pages.MainPage;
import com.javaseleniumtemplate.pages.TipoDeDespesasPage;
import org.testng.annotations.Test;
import org.testng.reporters.jq.Main;

public class TipoDeDespesasTests extends TestBase {

    MainPage mainPage;
    LoginFlows loginFlows;
    MainFlows mainFlows;
    TipoDeDespesasFlows tipoDeDespesasFlows;
    TipoDeDespesasPage tipoDeDespesasPage;

    @Test
    public void efetuarLancamentoDespesas(){
        mainPage = new MainPage();
        loginFlows = new LoginFlows();
        mainFlows = new MainFlows();
        tipoDeDespesasPage = new TipoDeDespesasPage();

        //Paramêtros
        String usuario = "leandro.ferreira@teknisa.com";
        String senha = "apresentacao";

        String TipoDespesa = "Despesa Automatizada";
        String TipoDespesa2 = "-EDITAR";
        String HistoricoPadrao = "DOC Nº [DOC] [RSC]";
        String ContaContabil = "5110100100001";
        String Contabiliza = "Sim";

        //Efetuar Login/Acessar Tela/Confirmar Filtro
        loginFlows.efetuarLogin(usuario,senha);
        mainFlows.navegarParaTipoDeDespesas();
        //tipoDeDespesasFlows.AplicarFiltro();

        //Confirmar Filtro
        tipoDeDespesasPage.clicarAplicarFiltro();

        //Adicionar Despesa
        tipoDeDespesasPage.clicarAdicionarDespesa();

        //Criar Lançamento
        tipoDeDespesasPage.preencherTipoDespesa(TipoDespesa);
        tipoDeDespesasPage.clicarPesquisaHistoricoPadrao();
       //tipoDeDespesasPage.preencherHistoricoPadrao(HistoricoPadrao);
        tipoDeDespesasPage.selecionarHistoricoPadrao();
        tipoDeDespesasPage.clicarPesquisaContaContabil();
        //tipoDeDespesasPage.preencherContaContabil(ContaContabil);
        tipoDeDespesasPage.selecionarContaContabil();
        tipoDeDespesasPage.salvarDespesa();
        tipoDeDespesasPage.clicarDespesaCadastrada();
        tipoDeDespesasPage.clicarEditarDespesa(TipoDespesa2);
        tipoDeDespesasPage.salvarDespesa();
        tipoDeDespesasPage.clicarExcluirDespesa();

    }

    @Test public void retornaDB(){
        String numeroconta = UsuariosDBSteps.retornaTituloPagarDB();
        System.out.println(numeroconta);
    }
}

