package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;

import java.util.concurrent.TimeUnit;

public class ContaContabilPage extends PageBase {

    //!!! Navegação Conta Contabil !!!
    By MenuPrincipalX = By.xpath("//div[@class='bars']");
    By Parametrizacao = By.xpath("//span[@class='menu-title ng-binding has-submenu'][text() = 'Parametrização']");
    By Contabil = By.xpath("/html/body/span/section/section/div[2]/section[1]/div/aside/div[2]/nav/ul/li[1]/ul/li[12]/ul/li[11]/span/span[3]");
    By ContaContabil = By.xpath("//span[@class='menu-title ng-binding'][text() = 'Conta Contábil']");

    //  Clicando em Adicionar Conta
    By ClicarAdcionar = By.xpath("//*[@id=\"footer\"]/div[2]/ul/li[3]/a/div");
    By PrimeiroClicarAdcionar = By.xpath("//div[@id='footer']/div[2]/ul/li/a/div");


    By CDCONTCTBL = By.id("CDCONTCTBL");
    By NMCONTCTBL = By.id("NMCONTCTBL");
    By CDCONTREDU = By.id("CDCONTREDU");
    By ClicarNaturezaConta = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[2]/div/div[3]/div/div/div[2]");
    By ContaAtivo = By.xpath("/html/body/span/section/section/div[2]/section[3]/div/div[4]/section/section/div/section/div/form/section[2]/div/div[3]/div/div/div[2]/ul/li[1]");
    By Salvar = By.xpath("//*[@id=\"footer\"]/div[3]/ul/li/a/span");

    By AtivoTeste = By.xpath("//*[text() = '6']");

    By AtivoCirculante = By.cssSelector(".tr:nth-child(7) svg");

    By AtivoDisponivel = By.cssSelector(".tr:nth-child(8) svg");

    By AtivoNumerarios = By.cssSelector(".tr:nth-child(9) svg");

    By AtivoCaixa = By.xpath("//*[@id=\"grid-7773626834103639319915\"]/div[2]/div/div[10]/div[1]/span[2]");

    By AtivoCaixaGeral = By.xpath("//*[text() = '6.1.1.01.001.00001']");

    By Voltar = By.xpath("//*[text() = 'Voltar']");

    By AtivoTesteII = By.cssSelector(".tr:nth-child(6) svg"); // Seta

    By AtivoCirculanteII = By.cssSelector(".zh-row-lvl-2 span:nth-child(2)"); // Nome da Conta

    By DisponivelII = By.cssSelector(".zh-row-lvl-3 span:nth-child(2)");

    By NumerariosII = By.cssSelector(".zh-row-lvl-4 span:nth-child(2)");


    public void AdicionarAtivoTeste(String CodigoAtivoTeste, String NomeAtivoTeste, String CodigoReduzidoAtivoTeste) {waitForElement(PrimeiroClicarAdcionar);
       click(PrimeiroClicarAdcionar);
       click(CDCONTCTBL);
       clear(CDCONTCTBL);
       sendKeys(CDCONTCTBL,CodigoAtivoTeste);
       click(NMCONTCTBL);
       sendKeys(NMCONTCTBL, NomeAtivoTeste);
       click(CDCONTREDU);
       clear(CDCONTREDU);
       sendKeys(CDCONTREDU, CodigoReduzidoAtivoTeste);
       click(ClicarNaturezaConta);
       click(ContaAtivo);
       click(Salvar);
    }

    public void AdicionarATIVOCIRCULANTE(String CodigoATIVOCIRCULANTE, String NomeATIVOCIRCULANTE, String CodigoReduzidoATIVOCIRCULANTE) {
        waitForElement(AtivoTeste);
        click(AtivoTeste);
        click(ClicarAdcionar);
        waitForElement(CDCONTCTBL);
        //clear(CDCONTCTBL);
        //click(CDCONTCTBL);
        //sendKeys(CDCONTCTBL, CodigoATIVOCIRCULANTE);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeATIVOCIRCULANTE);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoATIVOCIRCULANTE);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);

    }

    public void AdicionarDISPONIVEL(String CodigoDISPONIVEL, String NomeDISPONIVEL, String CodigoReduzidoDISPONIVEL) throws InterruptedException {
        click(AtivoTesteII);
        click(AtivoCirculanteII);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoDISPONIVEL);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeDISPONIVEL);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoDISPONIVEL);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);

    }
    public void AdicionarNUMERARIOS(String CodigoNUMERARIOS, String NomeNUMERARIOS, String CodigoReduzidoNUMERARIOS) {
        waitForElement(PrimeiroClicarAdcionar);
        click(AtivoCirculante);
        click(DisponivelII);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoNUMERARIOS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeNUMERARIOS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoNUMERARIOS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCAIXA(String CodigoCAIXA, String NomeCAIXA, String CodigoReduzidoCAIXA) {
        waitForElement(PrimeiroClicarAdcionar);
        click(AtivoDisponivel);
        click(NumerariosII);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCAIXA);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCAIXA);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCAIXA);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCAIXAGERAL(String CodigoCAIXAGERAL, String NomeCAIXAGERAL, String CodigoReduzidoCAIXAGERAL) {
        waitForElement(PrimeiroClicarAdcionar);
        click(AtivoNumerarios);
        click(AtivoCaixa);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCAIXAGERAL);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCAIXAGERAL);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCAIXAGERAL);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarATIVONAOCIRCULANTE(String CodigoATIVONAOCIRCULANTE, String NomeATIVONAOCIRCULANTE, String CodigoReduzidoATIVONAOCIRCULANTE) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoATIVONAOCIRCULANTE);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeATIVONAOCIRCULANTE);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoATIVONAOCIRCULANTE);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarDUPLICATARECEBER(String CodigoDUPLICATARECEBER, String NomeDUPLICATARECEBER, String CodigoReduzidoDUPLICATARECEBER) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoDUPLICATARECEBER);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeDUPLICATARECEBER);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoDUPLICATARECEBER);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarDUPLICATARECEBERLOJA(String CodigoDUPLICATARECEBERLOJA, String NomeDUPLICATARECEBERLOJA, String CodigoReduzidoDUPLICATARECEBERLOJA) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoDUPLICATARECEBERLOJA);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeDUPLICATARECEBERLOJA);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoDUPLICATARECEBERLOJA);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarDUPLICATARECEBERLOJAABC(String CodigoDUPLICATARECEBERLOJAABC, String NomeDUPLICATARECEBERLOJAABC, String CodigoReduzidoDUPLICATARECEBERLOJAABC) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoDUPLICATARECEBERLOJAABC);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeDUPLICATARECEBERLOJAABC);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoDUPLICATARECEBERLOJAABC);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarDUPLICATAS(String CodigoDUPLICATAS, String NomeDUPLICATAS, String CodigoReduzidoDUPLICATAS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoDUPLICATAS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeDUPLICATAS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoDUPLICATAS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarPASSIVOTeste(String CodigoPASSIVOTeste, String NomePASSIVOTeste, String CodigoReduzidoPASSIVOTeste) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoPASSIVOTeste);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomePASSIVOTeste);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoPASSIVOTeste);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarPASSIVOCIRCULANTE(String CodigoPASSIVOCIRCULANTE, String NomePASSIVOCIRCULANTE, String CodigoReduzidoPASSIVOCIRCULANTE) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoPASSIVOCIRCULANTE);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomePASSIVOCIRCULANTE);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoPASSIVOCIRCULANTE);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSFINANCIAMENTOS(String CodigoEMPRESTIMOSFINANCIAMENTOS, String NomeEMPRESTIMOSFINANCIAMENTOS, String CodigoReduzidoEMPRESTIMOSFINANCIAMENTOS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSFINANCIAMENTOS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSFINANCIAMENTOS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoEMPRESTIMOSFINANCIAMENTOS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSNACIONAIS(String CodigoEMPRESTIMOSNACIONAIS, String NomeEMPRESTIMOSNACIONAIS, String CodigoReduzidoNACIONAIS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSNACIONAIS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSNACIONAIS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoNACIONAIS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSMINASGERAIS(String CodigoEMPRESTIMOSMINASGERAIS, String NomeEMPRESTIMOSMINASGERAIS, String CodigoReduzidoEMPRESTIMOSMINASGERAIS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSMINASGERAIS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSMINASGERAIS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoEMPRESTIMOSMINASGERAIS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarBANCOITAU(String CodigoBANCOITAU, String NomeBANCOITAU, String CodigoReduzidoBANCOITAU) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoBANCOITAU);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeBANCOITAU);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoBANCOITAU);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarPASSIVONAOCIRCULANTE(String CodigoPASSIVONAOCIRCULANTE, String NomePASSIVONAOCIRCULANTE, String CodigoReduzidoPASSIVONAOCIRCULANTE) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoPASSIVONAOCIRCULANTE);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomePASSIVONAOCIRCULANTE);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoPASSIVONAOCIRCULANTE);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO(String CodigoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO, String NomeEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO, String CodigoReduzidoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoEMPRESTIMOSFINANCIAMENTOSLONGOPRAZO);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSNACIONAISLONGOPRAZO(String CodigoEMPRESTIMOSNACIONAISLONGOPRAZO, String NomeEMPRESTIMOSNACIONAISLONGOPRAZO, String CodigoReduzidoNACIONAISLONGOPRAZO) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSNACIONAISLONGOPRAZO);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSNACIONAISLONGOPRAZO);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoNACIONAISLONGOPRAZO);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarEMPRESTIMOSMINASGERAISLONGOPRAZO(String CodigoEMPRESTIMOSMINASGERAISLONGOPRAZO, String NomeEMPRESTIMOSMINASGERAISLONGOPRAZO, String CodigoReduzidoEMPRESTIMOSMINASGERAISLONGOPRAZO) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoEMPRESTIMOSMINASGERAISLONGOPRAZO);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeEMPRESTIMOSMINASGERAISLONGOPRAZO);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoEMPRESTIMOSMINASGERAISLONGOPRAZO);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarBANCOITAULONGOPRAZO(String CodigoBANCOITAULONGOPRAZO, String NomeBANCOITAULONGOPRAZO, String CodigoReduzidoBANCOITAULONGOPRAZO) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoBANCOITAULONGOPRAZO);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeBANCOITAULONGOPRAZO);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoBANCOITAULONGOPRAZO);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarRECEITASTeste(String CodigoRECEITAS, String NomeRECEITAS, String CodigoReduzidoRECEITAS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoRECEITAS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeRECEITAS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoRECEITAS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarRECEITASOPERACIONAISGERAIS(String CodigoRECEITASOPERACIONAISGERAIS, String NomeRECEITASOPERACIONAISGERAIS, String CodigoReduzidoRECEITASOPERACIONAISGERAIS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoRECEITASOPERACIONAISGERAIS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeRECEITASOPERACIONAISGERAIS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoRECEITASOPERACIONAISGERAIS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarRECEITASOPERACIONAIS(String CodigoRECEITASOPERACIONAIS, String NomeRECEITASOPERACIONAIS, String CodigoReduzidoRECEITASOPERACIONAIS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoRECEITASOPERACIONAIS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeRECEITASOPERACIONAIS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoRECEITASOPERACIONAIS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarRECEITABRUTA(String CodigoRECEITABRUTA, String NomeRECEITABRUTA, String CodigoReduzidoRECEITABRUTA) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoRECEITABRUTA);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeRECEITABRUTA);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoRECEITABRUTA);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarRECEITABRUTAVENDAS(String CodigoRECEITABRUTAVENDAS, String NomeRECEITABRUTAVENDAS, String CodigoReduzidoRECEITABRUTAVENDAS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoRECEITABRUTAVENDAS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeRECEITABRUTAVENDAS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoRECEITABRUTAVENDAS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarVENDAPRODUTO(String CodigoVENDAPRODUTO, String NomeVENDAPRODUTO, String CodigoReduzidoVENDAPRODUTO) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoVENDAPRODUTO);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeVENDAPRODUTO);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoVENDAPRODUTO);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCustosDespesasTeste(String CodigoCUSTODESPESAS, String NomeCUSTODESPESAS, String CodigoReduzidoCUSTODESPESAS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTODESPESAS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTODESPESAS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCUSTODESPESAS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCUSTOPRODUTOSSERVICOSVENDIDOS(String CodigoCUSTOPRODUTOSSERVIÇOS, String NomeCUSTOPRODUTOSSERVIÇOS, String CodigoReduzidoCUSTOPRODUTOSSERVIÇOS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTOPRODUTOSSERVIÇOS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTOPRODUTOSSERVIÇOS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCUSTOPRODUTOSSERVIÇOS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCUSTOPRODUTOSVENDIDOS(String CodigoCUSTOPRODUTOSVENDIDOS, String NomeCUSTOPRODUTOSVENDIDOS, String CodigoReduzidoCUSTOPRODUTOSVENDIDOS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTOPRODUTOSVENDIDOS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTOPRODUTOSVENDIDOS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCUSTOPRODUTOSVENDIDOS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCUSTOPRODUTOSVENDIDOSS(String CodigoCUSTOPRODUTOSVENDIDOSS, String NomeCUSTOPRODUTOSVENDIDOSS, String CodigoReduzidoCUSTOPRODUTOSVENDIDOSS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTOPRODUTOSVENDIDOSS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTOPRODUTOSVENDIDOSS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCUSTOPRODUTOSVENDIDOSS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCUSTOPRODUTOSVENDIDOSSS(String CodigoCUSTOPRODUTOSVENDIDOSSS, String NomeCUSTOPRODUTOSVENDIDOSSS, String CodigoReduzidoCUSTOPRODUTOSVENDIDOSSS) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTOPRODUTOSVENDIDOSSS);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTOPRODUTOSVENDIDOSSS);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoReduzidoCUSTOPRODUTOSVENDIDOSSS);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }
    public void AdicionarCUSTOPRODUTOSVENDIDOSFABRICA(String CodigoCUSTOPRODUTOSVENDIDOSFABRICA, String NomeCUSTOPRODUTOSVENDIDOSFABRICA, String CodigoReduzidoCUSTOPRODUTOSVENDIDOSFABRICA) {
        waitForElement(ClicarAdcionar);
        click(ClicarAdcionar);
        click(CDCONTCTBL);
        clear(CDCONTCTBL);
        sendKeys(CDCONTCTBL, CodigoCUSTOPRODUTOSVENDIDOSFABRICA);
        click(NMCONTCTBL);
        sendKeys(NMCONTCTBL, NomeCUSTOPRODUTOSVENDIDOSFABRICA);
        click(CDCONTREDU);
        clear(CDCONTREDU);
        sendKeys(CDCONTREDU, CodigoCUSTOPRODUTOSVENDIDOSFABRICA);
        click(ClicarNaturezaConta);
        click(ContaAtivo);
        click(Salvar);
    }

    public void AlertaUsuario() throws InterruptedException {
        this.driver.manage().timeouts().implicitlyWait(1, TimeUnit.MINUTES);
        driver.findElement(By.cssSelector("body > span > section > section > div.default-window > aside:nth-child(5) > aside > section > footer > button:nth-child(1)")).click();
    }


}