package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.ApuracaoImpostoPISFlows;
import com.javaseleniumtemplate.flows.MainFlows;
import com.javaseleniumtemplate.pages.ApuracaoImpostoPISPage;
import com.javaseleniumtemplate.pages.LoginPage;
import com.javaseleniumtemplate.pages.MainPage;
import org.testng.Assert;
import org.testng.annotations.Test;

public class ApuracaoImpostoPIS extends TestBase {

    // Objetos

    MainPage mainPage;
    LoginPage loginPage;
    MainFlows MainFlows;
    ApuracaoImpostoPISFlows ApuracaoImpostoPISFlows;
    ApuracaoImpostoPISPage ApuracaoImpostoPISPage;

    // Teste

    @Test
    public void efetuarLoginComSucesso() throws InterruptedException {

        //Objetos Instanciados

        mainPage = new MainPage();
        loginPage = new LoginPage();
        MainFlows = new MainFlows();
        ApuracaoImpostoPISFlows = new ApuracaoImpostoPISFlows();
        ApuracaoImpostoPISPage =  new ApuracaoImpostoPISPage();

        // Dados - Login

        String usuario = "operador24@AUTOMACAO_2184.com";
        String senha = "apresentacao";


        // Dados - Filtro Da Tela

        String tipodeapuracao = "Federal";
        String empresa = "HELA INGREDIENTES BRASIL";
        String imposto = "50 - PIS";



        // Dados - Inserção do Mapa de Apuração

        String nomedomapa = "Apuração de PIS";
        String datafinal = "31/01/2021";
        
        // Aba - Detalhamento - Botão ( Valor Ajuste Acrescimo )
        
        String valorAjusteAcrescimo = "7000";
        String valorBaseCalculo = "8000";
        String NumeroDoProcesso = "1001";
        String DescricaoAjuste = "Ajuste do Mapa 50 Pis";
        String DataDebSaida = "01/01/2030";
        String NumRecibo = "101";

        // ..........Teste Da Tela..........


        // !!!! LOGIN !!!!

        loginPage.preenhcerUsuario(usuario);
        loginPage.preencherSenha(senha);
        loginPage.clicarEmLogin();


        // !!! MENU !!!

        MainFlows.navegarParaApuracaoDeImposto();


        // !!! FILTRO DE APURAÇÃO !!!

        ApuracaoImpostoPISPage.clicarEmTipodeapuracao();
        ApuracaoImpostoPISPage.clicarEmEmpresa();
        ApuracaoImpostoPISPage.clicarEmImposto();
        ApuracaoImpostoPISPage.clicarAplicarFiltro();


        // !!! ADICIONAR MAPA !!!

        ApuracaoImpostoPISPage.clicarAdicionarMapa();


        // !!! CRIANDO MAPA DE APURAÇÃO !!!

        ApuracaoImpostoPISPage.preencherNomedomapa(nomedomapa);
        ApuracaoImpostoPISPage.clicarsalvarMapa();


        // !!! APURAÇÃO DO MAPA !!!

        ApuracaoImpostoPISPage.clicarEmMapaApuracao();
        ApuracaoImpostoPISPage.clicarEmAcoes();
        ApuracaoImpostoPISPage.clicarEmApurar();
        ApuracaoImpostoPISPage.clicarOk();


        // !!! SELECIONAR A ABA DE ( DETALHAMENTO ) !!!

        ApuracaoImpostoPISPage.clicarAbaDetalhamento();


        // !!! CAMPO ( Ajuste Acréscimo - Crédito/Entradas ) !!!!

        ApuracaoImpostoPISPage.clicarBotaoAjusteAcrescimo();
        ApuracaoImpostoPISPage.clicarEmAdicionar();
        ApuracaoImpostoPISPage.clicarEmCodigoAjuste();
        ApuracaoImpostoPISPage.clicarEmTipoCredito();
        ApuracaoImpostoPISPage.clicarEmRegimeApuracao();
        ApuracaoImpostoPISPage.preencherValorAjusAcresc(valorAjusteAcrescimo);
        ApuracaoImpostoPISPage.clicarEmSalvar();
        ApuracaoImpostoPISPage.clicarEmVoltar();


        // !!! CAMPO ( Ajuste Acréscimo - Débito Base ) !!!!

        ApuracaoImpostoPISPage.clicarBotaoAjusteAcrescimoDeb();
        ApuracaoImpostoPISPage.clicarEmAdicionar();
        ApuracaoImpostoPISPage.clicarEmAjusteBaseCalculo();
        ApuracaoImpostoPISPage.clicarEmRegimeApuracao();
        ApuracaoImpostoPISPage.clicarEmCSTAjusteDeb();
        ApuracaoImpostoPISPage.preencherValorBaseDeCalculo(valorBaseCalculo);
        ApuracaoImpostoPISPage.preencherNumeroDProcesso(NumeroDoProcesso);
        ApuracaoImpostoPISPage.preencherDescricaoDoAjuste(DescricaoAjuste);
        ApuracaoImpostoPISPage.preencherDataDebitoSaida(DataDebSaida);
        ApuracaoImpostoPISPage.clicarContaContabil();
        ApuracaoImpostoPISPage.clicarEstabelecimento();
        ApuracaoImpostoPISPage.preencherNrRecibo(NumRecibo);
        ApuracaoImpostoPISPage.clicarEmSalvar();
        ApuracaoImpostoPISPage.clicarEmVoltar();


        // !!! OPERAÇÕES NO MAPA DE APURAÇÃO !!!

        ApuracaoImpostoPISPage.clicarEmAcoes();
        ApuracaoImpostoPISPage.clicarEmApurar();
        ApuracaoImpostoPISPage.clicarEmSim();
        ApuracaoImpostoPISPage.clicarOk();

        ApuracaoImpostoPISPage.clicarAbaApuracaoDeImposto();

        ApuracaoImpostoPISPage.clicarEmExcluir();
        ApuracaoImpostoPISPage.clicarEmSim();
        ApuracaoImpostoPISPage.clicarOk();
    }
}
